/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program
  
 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/

#include "icons.h"
#include <qpixmap.h>

static const char* const m_catalog_icon_data[] = { 
"16 15 154 2",
"ax c None",
"ap c None",
"ao c None",
"#Y c None",
"aa c None",
"ad c None",
"ac c None",
"#1 c None",
"#0 c None",
"ab c None",
".e c None",
".n c None",
"#O c None",
"#Z c None",
"#H c None",
".# c None",
".o c None",
"Qt c None",
"#P c #000000",
"an c #ac3c41",
"a# c #000000",
".a c #eececd",
"aw c #000000",
"#N c #000000",
"ae c #080000",
"#A c #6a595a",
"aq c #311010",
".m c #bd5962",
"am c #73757b",
".d c #dec2cd",
"#X c #000000",
".D c #9c8594",
".b c #f6ced5",
"a. c #080400",
"#G c #310808",
".c c #ffe6ee",
".f c #ee99a4",
"#Q c #733839",
"#2 c #7b3839",
"al c #180c08",
"av c #391410",
".E c #ffb6b4",
"#z c #5a2420",
"#I c #ac696a",
"af c #833c39",
".P c #945d62",
".p c #ffbabd",
"ar c #7b3031",
"#M c #622c31",
"#u c #6a2429",
".l c #e66162",
"#q c #832829",
"#v c #bd696a",
".Z c #a4505a",
"#W c #733c41",
".u c #dea1a4",
".g c #f6d2de",
"#3 c #ac4041",
".C c #de5d62",
"#g c #9c5052",
".7 c #a44041",
"ak c #833439",
"ag c #9c3831",
".q c #f6cecd",
"#R c #b4484a",
"as c #943c41",
"#9 c #9c4852",
"#F c #8b3c41",
"#J c #c54c4a",
".t c #f6cecd",
"au c #9c404a",
"#B c #d54041",
".r c #f6d2d5",
".v c #f6c2c5",
".s c #f6d2d5",
".Q c #f68183",
".k c #f6b2bd",
"#4 c #d55052",
".F c #ffb2b4",
".h c #f6e6ee",
"#L c #bd484a",
"at c #c54041",
"#y c #cd4852",
"ah c #d54c52",
"#V c #de3c39",
"aj c #e63839",
"#r c #e63c39",
"#7 c #ee2020",
"#T c #ee2c29",
"#8 c #ee3839",
"ai c #f62429",
"#U c #f62829",
"#6 c #f62831",
"#K c #f63031",
"#E c #f63439",
"#w c #f63839",
"#5 c #f63c39",
"#t c #f6484a",
"#h c #ff3031",
"#f c #ff3431",
"#S c #ff3439",
".6 c #ff3839",
"#x c #ff3c41",
"#p c #ff4041",
"#o c #ff4441",
".8 c #ff444a",
".Y c #ff484a",
"#e c #ff4c4a",
"#C c #ff4c52",
"#D c #ff5052",
"#d c #ff555a",
".0 c #ff595a",
"#i c #ff5d5a",
"#n c #ff6162",
"#c c #ff6562",
"#s c #ff656a",
"#j c #ff696a",
".9 c #ff6d6a",
".O c #ff6d73",
"#k c #ff7173",
"#. c #ff7573",
".X c #ff757b",
"#b c #ff797b",
"#l c #ff7d83",
".R c #ff8183",
"#m c #ff8583",
".1 c #ff858b",
".S c #ff898b",
"## c #ff9194",
".2 c #ff9594",
".B c #ff959c",
".W c #ff999c",
".N c #ff9d9c",
".T c #ff9da4",
"#a c #ffa1a4",
".3 c #ffa5ac",
".G c #ffaaac",
".H c #ffaeac",
".A c #ffb2b4",
".5 c #ffb6b4",
".4 c #ffb6bd",
".M c #ffbabd",
".I c #ffbebd",
".z c #ffbec5",
".U c #ffc6c5",
".V c #ffc6cd",
".J c #ffcacd",
".y c #ffcecd",
".j c #ffd2d5",
".K c #ffd6de",
".L c #ffdee6",
".i c #ffe2e6",
".x c #ffe6e6",
".w c #ffeeee",
"Qt.#.a.b.c.d.e.f.g.h.i.j.k.l.m.n",
".o.p.q.r.s.t.u.v.w.x.y.z.A.B.C.D",
".E.F.G.H.I.J.K.L.L.j.J.M.G.N.O.P",
".Q.R.S.T.H.I.U.J.U.V.M.A.W.X.Y.Z",
".0.X.1.2.3.H.4.M.M.5.3.S.O.Y.6.7",
".8.9#..1##.T#a.3.N###b#c#d#e#f#g",
"#h#i#j#k#l.R.1#m#l#k.O#n#d#o#p#q",
"#r#e#i#s.9#..X#b#k.O#n.0#e#p#t#u",
"#v#w#d.0#s#s#j#j#s#n.0#e.8#x#y#z",
"#A#B#o#C#D.0.0.0#d#d.Y#p#E.8#F#G",
"#H#I#J.Y.Y.8#C.Y#e#o#p#K.6#L#M#N",
"#O#P#Q#R.Y#x#S.6#w#E#T#U#V#W#X#Y",
"#Z#0#1#2#3#4#5#K#6#7#U#8#9a.a#aa",
"#Oabacadaeafagah#8aiajakalamanao",
"#Z#0#1adap#Paqarasatauavawax#Pao"};

static const char* const m_unknown_icon_data[] = { 
"16 18 38 1",
". c None",
"y c #000000",
"d c #000000",
"x c #000000",
"H c #000000",
"c c #000000",
"G c #000000",
"t c #000000",
"n c #000000",
"s c #000000",
"w c #000000",
"J c #000000",
"D c #000000",
"B c #000000",
"v c #000000",
"r c #000000",
"C c #000000",
"l c #000000",
"k c #000000",
"I c #000000",
"j c #000000",
"q c #000000",
"b c #000000",
"a c #00385a",
"# c #003862",
"h c #00406a",
"o c #004473",
"g c #00508b",
"f c #005594",
"F c #00599c",
"e c #2981c5",
"u c #2985c5",
"m c #3185c5",
"z c #4191cd",
"p c #5299cd",
"i c #6aaad5",
"A c #6aaade",
"E c #8bbee6",
"....#a#a#abcd...",
"...aefbbbfgbbcd.",
"..hifbjklamgfbnd",
"..opbqrstsaugbvc",
"..#efbwx.yhzfblt",
"..cagfbnd.hzgblt",
"..ynbbbvcaAfbqvc",
"...ynBCDaEFbqrnd",
"....ycGaAFbqrnd.",
"......augbqrnd..",
"......#efbksd...",
"......cbbqvc....",
"......ynBBnd....",
".......aasx.....",
"......#ifbnd....",
"......HbbIJH....",
"......ynBBnd....",
".......yccd....."};

static const char* const m_cd_icon_data[] = { 
"16 16 140 2",
"Qt c None",
"#W c None",
"aj c None",
".Z c None",
"#g c None",
".t c None",
".c c None",
"#z c None",
".d c None",
".b c None",
".u c None",
"#5 c #000000",
"ah c #311000",
"ag c #000000",
"ae c #000000",
"af c #000000",
".k c #ffa500",
"#8 c #000000",
"#P c #000000",
"#0 c #180c00",
"ai c #5a2c00",
"#O c #000000",
"#Z c #000000",
"#X c #000000",
"#7 c #000000",
"ad c #834000",
"#Y c #000000",
"#6 c #000000",
".# c #ffffff",
"## c #9c5000",
"#4 c #a46d29",
".N c #cd8100",
"#n c #ff0000",
".e c #ffff8b",
"#a c #ff0000",
"#N c #945508",
".a c #ff7583",
"#o c #ffda20",
"#9 c #cd8908",
".E c #d58d10",
"#m c #bd7d18",
".v c #ffd6cd",
".s c #eea108",
"#J c #ffc218",
"#I c #b48129",
".l c #ffff9c",
"#y c #c58d31",
"#f c #ffca52",
".F c #ffee52",
".O c #ffff62",
"#Q c #ffba31",
"ac c #c58d39",
"#V c #c59d62",
".Y c #cd9d41",
"#t c #deaa52",
"ab c #deb252",
"#h c #eebe83",
"#u c #eec2a4",
"a# c #eec673",
"#3 c #eed2a4",
"#1 c #f6ae18",
"a. c #f6be52",
"#. c #f6da62",
"aa c #f6e2b4",
".w c #ff2000",
".f c #ff3000",
".G c #ff4800",
"#b c #ff4c18",
".P c #ff4c52",
".x c #ff5900",
".0 c #ff6118",
".n c #ff6900",
".R c #ff6d08",
".m c #ff6d41",
".1 c #ff7120",
".o c #ff7900",
".A c #ffa18b",
".Q c #ffa5c5",
".H c #ffb200",
".g c #ffbe7b",
".3 c #ffbeac",
".y c #ffc200",
"#s c #ffca29",
".5 c #ffca39",
".C c #ffd200",
".r c #ffd252",
"#D c #ffd600",
".j c #ffd641",
".i c #ffd66a",
".6 c #ffd67b",
".K c #ffda08",
"#L c #ffda18",
"#A c #ffda5a",
".J c #ffde39",
"#F c #ffdebd",
".z c #ffe200",
".L c #ffe210",
"#B c #ffe218",
"#q c #ffe239",
".4 c #ffe2a4",
".S c #ffe2de",
".9 c #ffe629",
".W c #ffe631",
"#C c #ffe641",
"#k c #ffe64a",
".8 c #ffe652",
".D c #ffe65a",
".M c #ffe66a",
".X c #ffea18",
".V c #ffea5a",
"#w c #ffea6a",
"#e c #ffea83",
".h c #ffeaa4",
"#R c #ffee20",
"#j c #ffee73",
"#r c #ffee83",
"#i c #ffee9c",
".U c #ffeec5",
"#p c #fff252",
"#2 c #fff26a",
".7 c #fff283",
"#S c #fff2a4",
"#G c #fff2e6",
"#K c #fff64a",
"#x c #fff652",
"#d c #fff69c",
"#v c #fff6ac",
"#M c #fff6b4",
"#U c #fff6c5",
".I c #fff6ee",
".p c #fff6ff",
"#E c #fffacd",
".T c #fffade",
"#c c #ffff41",
"#l c #ffff62",
".2 c #ffff94",
"#H c #ffffc5",
".B c #ffffee",
"#T c #fffff6",
".q c #ffffff",
"QtQtQtQt.#QtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQt.a.b.c.dQtQtQtQtQtQtQtQt",
"QtQtQt.e.f.g.h.i.j.kQtQtQtQtQtQt",
"QtQt.l.m.n.o.p.q.q.r.s.tQtQtQtQt",
".u.v.w.x.y.z.n.A.B.C.D.EQtQtQtQt",
"Qt.F.q.G.H.C.I.q.J.K.L.M.NQtQtQt",
"Qt.O.P.Q.R.S.T.U.K.V.W.X.Y.ZQtQt",
"Qt.0.1.2.3.q.4.5.6.7.8.9#.##QtQt",
"#a#b#c.V#d#e#f#g#h#i#j#k#l#mQtQt",
"#n#o#p#q.D#r#s#t#u.q#v#w#x#yQtQt",
"Qt#z#A#B#C#D#E#F#G.q.q.q#H#IQtQt",
"QtQt#J#K#D#L.q.q#M.q.q.q.q#NQtQt",
"Qt#O#P#Q#R#S.q#T#U#U.q.q#V#WQtQt",
"#X#Y#Z#0#1.q.q.q.q#2.q#3#4QtQtQt",
"#5#X#6#7#8#9a.a#aaabacadQtQtQtQt",
"QtQtQtaeafagQtahaiajQtQtQtQtQtQt"};

static const char* const m_dvd_icon_data[] = { 
"16 16 115 2",
"Qt c None",
"#J c None",
"#W c None",
".c c None",
".# c None",
"#K c #000000",
"#T c #000000",
".S c #414473",
".a c #8ba1ff",
".Z c #6279c5",
"#n c #000000",
".8 c #bddaff",
"#o c #29304a",
"#U c #525d9c",
"#O c #000000",
"#S c #525994",
".b c #8391e6",
".r c #cde6ff",
"#w c #000000",
".j c #94a5e6",
"#y c #000000",
".B c #52558b",
"#z c #31385a",
"#L c #000000",
"#N c #000000",
"#V c #4a598b",
"#M c #000000",
"#x c #000000",
"#e c #6a6da4",
"#v c #525d94",
"#I c #414883",
".1 c #4a4c7b",
"#H c #4a558b",
"#l c #10185a",
".d c #d5e6ff",
".7 c #52598b",
".v c #7b81bd",
".2 c #c5daff",
".k c #deeeff",
"#f c #c5d6ff",
".Y c #bdcaff",
".q c #94a1de",
".w c #d5eaff",
"#P c #b4c6ff",
".T c #d5e6ff",
".C c #d5e6ff",
".I c #d5e6ff",
"#m c #acb2cd",
".H c #9495bd",
".3 c #b4bee6",
"#q c #8b95cd",
"#G c #9499c5",
".z c #94aef6",
"#s c #9ca1c5",
"#E c #9ca1cd",
".9 c #9cb2f6",
"#R c #a4aad5",
".R c #a4aed5",
"#h c #a4aede",
".F c #a4baff",
"#a c #acb2d5",
"#Q c #acb2e6",
".E c #acbef6",
".Q c #acbeff",
".P c #acc2f6",
".G c #acc2ff",
".0 c #b4bade",
".O c #b4bee6",
".e c #b4c2f6",
".U c #b4c2ff",
".n c #b4c6ff",
".A c #bdc2ee",
".f c #bdcaee",
".J c #bdcaf6",
".V c #bdcaff",
".5 c #bdceff",
"#i c #c5c2de",
".N c #c5caee",
".i c #c5cef6",
".t c #c5ceff",
"#A c #c5d2ff",
"#b c #cdcade",
"#C c #cdcee6",
".h c #cdd2ee",
".K c #cdd6ff",
".X c #cddaff",
"#j c #d5d2e6",
".4 c #d5d2ee",
"#r c #d5d6ee",
"#B c #d5daf6",
".W c #d5daff",
".M c #d5deff",
".6 c #d5e2ff",
"#t c #dedae6",
"#c c #dedaee",
"#d c #dedaf6",
"#. c #dedaff",
"## c #dee2f6",
".D c #dee2ff",
".m c #dee6ff",
"#u c #e6e2ee",
".g c #e6e2ff",
".p c #e6e6f6",
"#p c #e6e6ff",
"#F c #e6eaf6",
".L c #e6eaff",
".s c #e6eeff",
".u c #eeeeff",
"#k c #eef2f6",
"#D c #eef2ff",
"#g c #eef6ff",
".x c #f6f2ff",
".y c #f6f6ff",
".o c #fffaff",
".l c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQt.#.a.b.cQtQtQtQtQtQtQtQt",
"QtQtQt.d.e.f.g.h.i.jQtQtQtQtQtQt",
"QtQt.k.l.m.n.o.l.l.p.qQtQtQtQtQt",
"Qt.r.s.l.l.t.u.l.l.l.o.vQtQtQtQt",
"Qt.w.l.l.l.x.m.l.l.y.z.A.BQtQtQt",
"Qt.C.m.o.l.l.D.x.l.E.F.G.HQtQtQt",
"Qt.I.J.K.L.y.M.N.O.t.P.Q.R.SQtQt",
"Qt.T.U.V.W.X.Y.Z.0.W.t.G.M.1QtQt",
"Qt.2.J.Q.J.D.L.3.4.l.M.5.6.7QtQt",
"Qt.8.K.9.5.i#..p###a.o#b#b#c#d#e",
"QtQt#f.V#g.x#h.h.y.l#i#j#k#l.l#m",
"Qt#n#o.6#p.l.4.p#q.o#r#s.l#t#u#v",
"#w#x#y#z#A#B#C#D.L#E#F#G#H#I#JQt",
"#K#L#M#N#O#P.W#p.g#Q#R#SQtQtQtQt",
"QtQtQt#K#TQtQt#U#V#WQtQtQtQtQtQt"};

static const char* const m_hdd_icon_data[] = { 
"16 16 105 2",
"Qt c None",
".1 c None",
"#j c None",
"#K c None",
"#A c None",
"#s c None",
".K c None",
".y c None",
".n c None",
"#G c None",
".h c None",
"#t c None",
"#k c None",
".# c None",
".c c None",
"## c None",
".i c None",
".o c None",
"#M c #000020",
"#L c #62657b",
"#z c #080439",
"#r c #000031",
".z c #f6f2ff",
"#F c #181841",
"#J c #39385a",
".p c #cdced5",
".j c #cdcad5",
".T c #ded6e6",
".2 c #d5d2d5",
".L c #dedae6",
".b c #b4b6c5",
".d c #c5c2cd",
"#H c #9495a4",
".g c #acaab4",
"#q c #62657b",
"#B c #9495a4",
".m c #9c9dac",
"#y c #737583",
"#u c #a4a1ac",
"#E c #8b899c",
".x c #a4a1ac",
".a c #ded6e6",
"#l c #b4b2bd",
"#I c #94919c",
".J c #a4a5b4",
".A c #dedade",
"#a c #cdc2d5",
".S c #9c99ac",
".q c #e6e2ee",
"#v c #5a5d83",
".4 c #5aea62",
"#C c #62658b",
"#f c #7b799c",
"#w c #837da4",
"#m c #83819c",
"#e c #8381a4",
".9 c #8b89a4",
"#. c #8b8dac",
".8 c #948dac",
".7 c #9495ac",
".Z c #9c99ac",
"#n c #9c99b4",
".W c #9c9db4",
"#i c #a49dac",
".Y c #a4a1b4",
".X c #a4a1bd",
"#x c #a4a5bd",
".Q c #acaabd",
"#g c #acaac5",
".O c #acaec5",
".P c #b4b2c5",
"#D c #b4b6c5",
".N c #bdb6cd",
".R c #bdbacd",
".G c #c5becd",
".V c #c5bed5",
".6 c #c5c2cd",
".H c #c5c2d5",
".F c #cdc6d5",
"#h c #cdcade",
"#p c #cdced5",
"#c c #d5cede",
".v c #d5d2de",
"#d c #d5d2e6",
".M c #d5d6de",
"#b c #d5e2de",
".u c #ded6e6",
".I c #dedae6",
"#o c #dedaee",
".3 c #deffe6",
".0 c #e6dee6",
".C c #e6e2ee",
".E c #e6e6ee",
".D c #eee6ee",
".B c #eee6f6",
".k c #eeeaee",
".w c #eeeaf6",
".U c #eeeeee",
".5 c #f6eaff",
".s c #f6f2f6",
".e c #f6f2ff",
".l c #f6f6ff",
".t c #fff6ff",
".r c #fffaff",
".f c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.#.a.bQtQtQtQtQtQt",
"QtQtQtQtQt.c.d.e.f.f.g.hQtQtQtQt",
"QtQtQt.i.j.k.f.f.f.l.f.m.nQtQtQt",
"Qt.o.p.q.f.r.s.l.t.u.v.w.x.yQtQt",
".z.A.e.k.B.C.D.E.F.G.H.H.I.J.KQt",
".L.f.v.v.v.v.M.N.O.P.P.P.Q.R.SQt",
".T.U.f.F.V.H.N.W.X.Y.W.Z.V.f.0.1",
".2.3.4.5.6.O.7.8.9#..P.C.k.f.M.1",
"###a#b#c#d.H#e#f#g.H.R#h.D.f#i#j",
"Qt#k#l.u.P.P.H.X#m#n.O#o#p#q#r#s",
"QtQt#t#u#h.7.N#v#w#x.F#y#z#AQtQt",
"QtQtQt.h#B.V.Q#C#D#E#F#AQtQtQtQt",
"QtQtQtQt#G#H.R#I#J#KQtQtQtQtQtQt",
"QtQtQtQtQtQt#L#MQtQtQtQtQtQtQtQt"};

static const char* const m_net_icon_data[] = { 
"16 16 108 2",
"Qt c None",
"#L c None",
".Y c None",
".Q c None",
"#F c None",
"#u c None",
"#f c None",
"#M c None",
"#p c None",
"#G c None",
".f c None",
".v c None",
".G c None",
".p c None",
".b c None",
".Z c None",
"#B c #52505a",
".8 c #ffffff",
".X c #000029",
"#E c #000029",
".u c #626173",
".# c #c5c2c5",
".h c #f6eeee",
".F c #181431",
".P c #000029",
".q c #ffffff",
"#C c #9c99a4",
".g c #ffffff",
"#t c #080c29",
"#v c #ee9100",
".a c #8b8d8b",
"#y c #945000",
".l c #f69d00",
"#g c #dedade",
".o c #c57500",
".O c #525552",
".9 c #7b7d7b",
"#P c #a4a59c",
".H c #c58508",
".w c #4a4c52",
".R c #ffd600",
"#s c #736d6a",
".i c #7b757b",
"#J c #000000",
".C c #000c18",
".s c #080808",
".1 c #101420",
"#r c #313031",
"#H c #4a484a",
"#z c #52595a",
"#n c #5a6173",
"#. c #626162",
".e c #626562",
".k c #626973",
".r c #6a656a",
"#e c #6a696a",
"#j c #73694a",
"#h c #736d73",
"#N c #73757b",
".x c #838594",
"## c #83899c",
".0 c #8b7d62",
".D c #9c999c",
".j c #a4a1a4",
".t c #aca5ac",
"#A c #acaaac",
"#q c #acaeac",
".E c #b4b2ac",
".c c #b4b6bd",
"#c c #b4bede",
".M c #bd8952",
".6 c #bda15a",
"#I c #bdb6bd",
".2 c #c5bab4",
"#D c #c5c2c5",
"#o c #c5c6cd",
".N c #c5cad5",
".5 c #cdb273",
".B c #d59108",
"#K c #d5d2cd",
"#d c #d5deee",
"#i c #dedade",
"#O c #dedede",
".W c #e69100",
".7 c #ee8d00",
"#b c #eeba39",
"#x c #f69d00",
"#w c #ffa500",
"#k c #ffbe20",
".y c #ffc218",
".n c #ffc220",
"#m c #ffca08",
"#l c #ffca10",
".m c #ffca29",
".V c #ffce18",
".L c #ffd218",
".K c #ffd24a",
".U c #ffd652",
".4 c #ffe26a",
".T c #ffe694",
"#a c #ffee94",
".3 c #fff6c5",
".J c #fffade",
".S c #fffaf6",
".I c #ffffcd",
".z c #ffffd5",
".A c #fffff6",
".d c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQt.#.a.bQtQtQtQtQtQtQtQtQtQtQt",
"QtQt.c.d.e.fQtQtQtQtQtQtQt.g.hQt",
"QtQt.i.j.d.k.l.m.n.o.p.q.r.s.t.u",
"QtQt.v.w.x.y.z.d.d.A.B.C.D.d.E.F",
"QtQtQt.G.H.I.d.d.J.K.L.M.N.O.P.Q",
"QtQtQtQt.R.d.d.S.T.U.V.W.X.YQtQt",
"QtQtQt.Z.0.1.2.3.4.5.6.7.QQtQtQt",
"Qt.8.9.s#..d###a#b#c#d#e#fQtQtQt",
"#g#.#h.d#i#j#k#l#m#n#o.d#e#pQtQt",
"#q#r.d#s#t#u#v#w#x#y#z#A.d.D#BQt",
"#C#D#E.YQtQtQt#F#F.Q#G#H#I#J#K#L",
"Qt.QQtQtQtQtQtQtQtQtQt#M#N#O#P.Y",
"QtQtQtQtQtQtQtQtQtQtQtQtQt.Y.YQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const m_flash_icon_data[] = { 
"16 16 97 2",
".e c #2048a4",
".j c #2050a4",
".f c #3155ac",
".q c #3165ac",
".d c #395dac",
".n c #3961ac",
".A c #3969b4",
".# c #415dac",
"Qt c #4161b4",
".a c #4165b4",
".s c #4169b4",
".U c #4179bd",
".b c #4a65b4",
".c c #4a69b4",
".h c #4a71b4",
".o c #4a71bd",
".x c #4a79bd",
".R c #4a79c5",
".J c #4a7dbd",
".g c #5271bd",
".i c #5275bd",
".X c #5289c5",
"#. c #5291c5",
".k c #5a79bd",
".p c #5a7dbd",
".t c #5a7dc5",
".D c #5a85c5",
".W c #5a8dc5",
".V c #5a8dcd",
".v c #6289c5",
".F c #628dc5",
".O c #628dcd",
".K c #6291c5",
".H c #6291cd",
".N c #6295cd",
".4 c #6299cd",
".E c #6a89c5",
".G c #6a89cd",
".w c #6a8dc5",
".u c #6a91cd",
".I c #6a95c5",
".M c #6a99cd",
".7 c #6a9dcd",
".6 c #6aa1cd",
".L c #7399cd",
"#a c #73a1cd",
".5 c #73a1d5",
"#p c #73a5d5",
".Y c #7ba1d5",
"#b c #7baad5",
"#j c #7baed5",
"#h c #7baede",
".C c #83a1d5",
".8 c #83aed5",
"#d c #83b2d5",
"#i c #83b2de",
"#o c #83b6de",
"#s c #83bade",
"#c c #8bb2de",
"#f c #8bb6de",
"#u c #8bb6e6",
"#k c #8bbade",
"#l c #8bbede",
"#B c #8bc2e6",
".S c #94b2de",
"#e c #94b6e6",
"#g c #94bae6",
"#n c #94bede",
"#m c #94bee6",
"#E c #94c2e6",
".P c #9cbade",
"#t c #9cc2e6",
"#v c #9cc6e6",
"#x c #9ccae6",
"#C c #9ccaee",
".2 c #a4c2de",
"#y c #a4c6ee",
"#w c #a4cae6",
"#D c #a4caee",
"#z c #a4ceee",
".0 c #acc6e6",
".1 c #accae6",
".m c #b4c2e6",
".Q c #b4ceee",
"#r c #b4d2ee",
".B c #bdcae6",
".3 c #bdd2ee",
"#q c #c5daee",
".T c #d5def6",
".Z c #d5e6f6",
"## c #dee6f6",
".y c #e6eaff",
"#A c #e6f2ff",
".r c #eeeef6",
".9 c #eeeeff",
".z c #fffaff",
".l c #ffffff",
"Qt.#Qt.#Qt.#Qt.#Qt.#Qt.#Qt.#Qt.#",
".a.b.a.c.a.b.d.e.f.c.a.c.a.b.a.c",
".g.h.i.h.g.j.k.l.m.n.i.o.g.h.i.o",
".k.p.p.k.q.l.l.l.r.s.p.p.p.p.k.t",
".u.v.w.x.y.z.A.B.C.D.E.F.G.F.E.F",
".F.H.I.H.l.J.K.F.K.L.M.L.N.O.I.L",
".P.Q.R.S.T.U.O.F.V.W.O.X.Y.Z.V.u",
".l.l.l.l.l.l.l.l.l.l.l.l.l.l.l.0",
".l.l.l.l.l.l.l.l.l.l.l.l.l.l.l.1",
".2.3.4.5.6.7.8.9#..5.6.6.8###a#b",
"#c#d#e#f#g#f#h.l#h#i#i#i#f#j#k#k",
"#l#m#n#m#n#m#o.Z.l#p#q#r#s#m#n#g",
"#t#t#t#t#t#t#t#i.z.l.l.l#u#t#t#t",
"#v#w#t#x#v#y#v#v#s#z.l#A#B#C#t#x",
"#D#D#z#w#z#w#z#w#D#v#E#E#D#w#z#w",
"#w#z#w#z#w#z#w#z#w#z#w#z#w#z#w#z"};

static const char* const m_other_icon_data[] = { 
"16 16 103 2",
"Qt c None",
"#p c None",
"#j c None",
"#K c None",
".n c None",
".Z c None",
".O c None",
".c c None",
".# c #d5cef6",
"#k c #d5d6ff",
"#H c #9c99cd",
"#a c #d5d2f6",
".F c #c5baee",
".h c #9491cd",
"#B c #9c9dde",
"#v c #7375c5",
".N c #bdb6e6",
"#C c #c5beee",
".Y c #bdaee6",
"#w c #d5cef6",
"#G c #9491cd",
".y c #6a69b4",
"#J c #7b79ac",
".d c #eeeaff",
".b c #c5beee",
".s c #ffffff",
"#q c #e6e2ff",
"## c #aca5de",
".i c #fffaff",
".v c #f6f6ff",
".I c #8b89bd",
".Q c #9c95c5",
".u c #acb2f6",
".z c #fffaff",
".D c #948db4",
".a c #c5c2de",
".e c #eeeaff",
".0 c #9c9dbd",
"#I c #c5c6de",
"#u c #cdc6f6",
".1 c #eee6f6",
".C c #acaee6",
".j c #e6e6f6",
".G c #f6f6ff",
"#A c #cdc6ee",
".R c #ffeef6",
".H c #c5c6ee",
"#F c #d5cef6",
".P c #dedef6",
".J c #ffffff",
".E c #fffaff",
".9 c #0034d5",
"#h c #0038cd",
"#g c #003cd5",
".8 c #185dd5",
".W c #187df6",
"#n c #2079ee",
".V c #29a1ff",
"#f c #3981ee",
"#m c #4a9df6",
".7 c #4aa5ff",
".L c #4aaeff",
".6 c #5abaff",
".U c #62b6ff",
"#e c #73c6ff",
"#l c #7bcaff",
"#s c #83caff",
"#d c #83ceff",
".T c #83d2ff",
"#o c #8bbeff",
".5 c #8bceff",
"#i c #94beff",
".K c #a4deff",
".4 c #ace2ff",
"#t c #b4daff",
"#c c #b4e6ff",
".r c #bdc6ff",
".x c #c5caff",
"#. c #c5e2ff",
".m c #cdceff",
".f c #cdd2ee",
".g c #cdd2ff",
"#z c #d5d2ff",
"#E c #d5d6ff",
".3 c #d5ffff",
"#y c #dedaff",
".B c #dedeff",
"#b c #deffff",
".t c #e6e2f6",
".k c #e6e6f6",
"#D c #e6e6ff",
".X c #e6f2ff",
".S c #e6ffff",
"#x c #eeeeff",
".M c #eef2ff",
".o c #f6eeff",
".w c #f6f2f6",
".q c #f6f2ff",
"#r c #f6f6ff",
".2 c #f6ffff",
".p c #fffaf6",
".A c #fffaff",
".l c #ffffff",
"QtQtQtQtQtQtQtQt.#.a.bQtQtQtQtQt",
"QtQtQtQtQt.c.d.e.f.g.hQtQtQtQtQt",
"QtQtQt.c.i.j.k.k.l.m.nQtQtQtQtQt",
"QtQt.c.o.p.q.l.l.l.rQtQtQtQtQtQt",
"QtQt.s.l.q.l.l.l.t.uQtQtQtQtQtQt",
"QtQt.v.l.w.l.l.q.x.yQtQtQtQtQtQt",
"QtQt.z.A.l.l.B.C.D.E.FQtQtQtQtQt",
"QtQt.G.q.w.H.I.J.K.L.M.NQtQtQtQt",
"Qt.O.l.P.Q.R.S.T.U.V.W.X.YQtQtQt",
"Qt.Z.0.1.2.3.4.5.6.7.8.9#.##QtQt",
"Qt#a.l.l.l#b#c#d#e#f#g#h#i.q#jQt",
"Qt#k.l.l.l.l.4#l#m#n#o.l.l.q#pQt",
"QtQt#q.l#r.l.l#s#t.l.q.A#u#vQtQt",
"QtQtQt#w#x#y.l.A#z.q#A#BQtQtQtQt",
"QtQtQtQt#C.B#D#E#F#GQtQtQtQtQtQt",
"QtQtQtQtQt#H#I#J#KQtQtQtQtQtQtQt"};

static const char* const m_floppy_icon_data[] = { 
"16 16 140 2",
"Qt c None",
"#Z c None",
"ag c None",
"aj c None",
".1 c None",
".e c None",
".# c None",
".f c None",
".n c None",
"#D c #000000",
"a# c #000000",
"#0 c #000000",
".R c #eee6ee",
"aa c #000000",
"#O c #000000",
"#R c #000000",
"#E c #000000",
"ab c #000000",
"#t c #292829",
"#3 c #000000",
"ah c #393c39",
"#F c #202020",
"#C c #181c18",
"#Q c #000000",
"#2 c #000000",
"#P c #000000",
".G c #7b797b",
"#1 c #000000",
"a. c #202429",
"#N c #202020",
"#b c #bdbebd",
"#4 c #414441",
".H c #f6f2f6",
"#a c #4a4441",
".a c #cdc6c5",
"ai c #312c29",
".o c #dedade",
"#u c #949194",
".g c #d5d2d5",
".m c #9c959c",
"af c #292c29",
"#S c #6a696a",
".2 c #bdbabd",
".x c #d5d6d5",
".Q c #737173",
".b c #d5ced5",
"#k c #a4a5a4",
"#Y c #313039",
"#M c #292831",
"#9 c #313439",
"#B c #393c4a",
"ae c #413c41",
"#X c #414052",
"#j c #525052",
"#s c #525962",
"ac c #625d62",
"#8 c #6a657b",
".0 c #6a696a",
"#r c #7371a4",
"## c #737594",
"#i c #7b79a4",
".Z c #8b89ac",
"#. c #8b8d94",
".F c #948d94",
".w c #949194",
".P c #9491ac",
".O c #9c95b4",
"#L c #9c99a4",
"#5 c #9c9d9c",
".E c #9c9dac",
".u c #a4a1ac",
".z c #acaaac",
".k c #acaab4",
".v c #acaabd",
".l c #acaeb4",
".J c #b4b2b4",
"#G c #b4b2d5",
".d c #bdb6bd",
"#7 c #bdbab4",
".h c #bdbabd",
".C c #bdbac5",
"ad c #bdbacd",
".W c #bdbad5",
".N c #bdbed5",
"#T c #bdbede",
"#v c #c5c2c5",
".5 c #c5c2cd",
"#6 c #c5c2de",
".c c #c5c6c5",
".i c #cdc6cd",
".p c #cdcacd",
".D c #cdcad5",
".M c #cdcade",
".I c #cdced5",
"#A c #d5b27b",
"#W c #d5c29c",
"#U c #d5ce7b",
".A c #d5ced5",
".q c #d5d2d5",
".L c #d5d2de",
"#h c #debe52",
"#n c #deceac",
".V c #ded6e6",
".6 c #dedee6",
".K c #dedeee",
"#l c #e6deee",
".T c #e6e2e6",
".U c #e6e2ee",
".Y c #e6e68b",
".j c #e6e6e6",
"#m c #e6e6f6",
".X c #eee6c5",
".t c #eeeaee",
"#c c #eeeaf6",
"#d c #f6d6ac",
".4 c #f6eef6",
".3 c #f6f2f6",
".B c #f6f6f6",
"#q c #ffc608",
"#z c #ffce00",
"#y c #ffce18",
"#K c #ffd64a",
"#J c #ffda18",
"#p c #ffde31",
"#x c #ffe641",
"#V c #ffee31",
"#I c #ffee41",
"#o c #fff252",
"#g c #fff641",
"#w c #fff662",
".y c #fff6f6",
".S c #fff6ff",
"#H c #fffa83",
".r c #fffaff",
".9 c #ffff62",
"#f c #ffff8b",
".8 c #ffff9c",
"#e c #ffffb4",
".7 c #ffffc5",
".s c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.#.a.b.c.d.eQtQtQt",
"QtQtQtQtQt.f.g.h.i.j.k.l.mQtQtQt",
"QtQtQt.n.o.p.q.r.s.t.u.v.wQtQtQt",
"QtQtQt.x.y.z.A.B.C.D.D.E.F.GQtQt",
"QtQt.H.j.s.I.J.K.L.M.N.O.P.QQtQt",
"QtQt.R.c.S.T.U.V.M.W.X.Y.Z.0.1Qt",
"QtQtQt.2.3.4.5.M.6.7.8.9#.###aQt",
"QtQtQt#b.A#c.5.s#d#e#f#g#h#i#jQt",
"QtQtQtQt#k#l.L#m#n.8#o#p#q#r#s#t",
"QtQtQtQt#u.6.V#v#e#w#x#y#z#A#B#C",
"QtQt#D#E#F.w.D#G#H#I#J#K#L#M#NQt",
"Qt#O#P#Q#R#S#m#T#U#V#W#X#Y#ZQtQt",
"#0#1#P#2#3#4#5#6#7#8#9a.QtQtQtQt",
"QtQta#aaab#OacadaeafagQtQtQtQtQt",
"QtQtQtQtQtQtahaiajQtQtQtQtQtQtQt"};


static const char * v_folderlocked_icon_data[]={
    "16 16 10 1",
    "h c #808080",
    "b c #ffa858",
    "f c #c0c0c0",
    "e c #c05800",
    "# c #000000",
    "c c #ffdca8",
    ". c None",
    "a c #585858",
    "g c #a0a0a4",
    "d c #ffffff",
    "..#a#...........",
    ".#abc####.......",
    ".#daa#eee#......",
    ".#ddf#e##b#.....",
    ".#dfd#e#bcb##...",
    ".#fdccc#daaab#..",
    ".#dfbbbccgfg#ba.",
    ".#ffb#ebbfgg#ba.",
    ".#ffbbe#bggg#ba.",
    ".#fffbbebggg#ba.",
    ".##hf#ebbggg#ba.",
    "...###e#gggg#ba.",
    ".....#e#gggg#ba.",
    "......###ggg#b##",
    ".........##g#b##",
    "...........####."};


static const char* v_folderclosed_icon_data[]={
    "16 16 9 1",
    "g c #808080",
    "b c #c0c000",
    "e c #c0c0c0",
    "# c #000000",
    "c c #ffff00",
    ". c None",
    "a c #585858",
    "f c #a0a0a4",
    "d c #ffffff",
    "..###...........",
    ".#abc##.........",
    ".#daabc#####....",
    ".#ddeaabbccc#...",
    ".#dedeeabbbba...",
    ".#edeeeeaaaab#..",
    ".#deeeeeeefe#ba.",
    ".#eeeeeeefef#ba.",
    ".#eeeeeefeff#ba.",
    ".#eeeeefefff#ba.",
    ".##geefeffff#ba.",
    "...##gefffff#ba.",
    ".....##fffff#ba.",
    ".......##fff#b##",
    ".........##f#b##",
    "...........####."};

static const char* v_folderopen_icon_data[]={
    "16 16 11 1",
    "# c #000000",
    "g c #c0c0c0",
    "e c #303030",
    "a c #ffa858",
    "b c #808080",
    "d c #a0a0a4",
    "f c #585858",
    "c c #ffdca8",
    "h c #dcdcdc",
    "i c #ffffff",
    ". c None",
    "....###.........",
    "....#ab##.......",
    "....#acab####...",
    "###.#acccccca#..",
    "#ddefaaaccccca#.",
    "#bdddbaaaacccab#",
    ".eddddbbaaaacab#",
    ".#bddggdbbaaaab#",
    "..edgdggggbbaab#",
    "..#bgggghghdaab#",
    "...ebhggghicfab#",
    "....#edhhiiidab#",
    "......#egiiicfb#",
    "........#egiibb#",
    "..........#egib#",
    "............#ee#"};

static const char * v_file_icon_data []={
    "16 16 7 1",
    "# c #000000",
    "b c #ffffff",
    "e c #000000",
    "d c #404000",
    "c c #c0c000",
    "a c #ffffc0",
    ". c None",
    "................",
    ".........#......",
    "......#.#a##....",
    ".....#b#bbba##..",
    "....#b#bbbabbb#.",
    "...#b#bba##bb#..",
    "..#b#abb#bb##...",
    ".#a#aab#bbbab##.",
    "#a#aaa#bcbbbbbb#",
    "#ccdc#bcbbcbbb#.",
    ".##c#bcbbcabb#..",
    "...#acbacbbbe...",
    "..#aaaacaba#....",
    "...##aaaaa#.....",
    ".....##aa#......",
    ".......##......."};


static const char* const v_back_icon_data[] = { 
"18 18 148 2",
"Qt c None",
".k c None",
".v c #000000",
"aj c #ffffff",
".D c #000000",
"a. c #ffffff",
".# c #ffffff",
".1 c #000000",
"#0 c #e6dee6",
"#Z c #ffffff",
"## c #000000",
"#9 c #000000",
"ai c #000000",
"#h c #000000",
"#O c #ffffff",
"#o c #000000",
".a c #ffffff",
"#Y c #000000",
".l c #ffffff",
"#8 c #000000",
".j c #8bc6ff",
"ak c #2079d5",
".S c #5a99de",
".b c #ffffff",
".E c #ffffff",
"#D c #94c6ff",
".m c #ffffff",
".w c #ffffff",
"ar c #185594",
"#N c #205994",
".u c #7bbaff",
".c c #deeeff",
"a# c #2989ee",
".J c #6aaaee",
"#P c #52a5ff",
".K c #deeeff",
".i c #94caff",
"#1 c #3191f6",
".C c #73b6f6",
"al c #2085ee",
".0 c #5aa1ee",
"ah c #206dc5",
"#X c #2971c5",
"#v c #83c2ff",
"aq c #1875cd",
"#C c #3181d5",
".n c #cde6ff",
".F c #cde6ff",
".d c #c5e2ff",
"#7 c #2979cd",
".T c #bddeff",
".x c #cde6ff",
".h c #9cceff",
"am c #2089f6",
"#. c #5aa5f6",
"#p c #83c2ff",
"ap c #2089ee",
"#u c #4199ee",
".e c #bddeff",
".2 c #acd6ff",
"an c #2991ff",
"#g c #5aaaff",
".g c #acd2ff",
"ao c #2091ff",
"#n c #4aa5ff",
"#i c #94c6ff",
".f c #acd6ff",
"#a c #94caff",
"#d c #0099ff",
".O c #009dff",
".6 c #089dff",
".X c #109dff",
"#y c #18a5ff",
".H c #29aaff",
"#m c #31aeff",
"#l c #39b2ff",
".5 c #41b2ff",
"#z c #41b6ff",
"ag c #4aa1ff",
"#M c #5aaaff",
"aa c #5aaeff",
".Y c #5abeff",
"#R c #62c2ff",
"#s c #6ac2ff",
"#6 c #73b2f6",
"#W c #73b6f6",
"#E c #73b6ff",
"#2 c #7bb6ff",
"#Q c #7bbaff",
"af c #83baf6",
".N c #83ceff",
".R c #8bc6ff",
"ab c #9cc6f6",
"#B c #9cc6ff",
"#c c #9ccef6",
".t c #9cceff",
"#I c #9cd6ff",
"#w c #a4cef6",
"ae c #acceee",
".I c #acd6ff",
"#H c #acdaff",
".Z c #b4d6ff",
".B c #b4daff",
"#e c #b4e2ff",
"#5 c #bdd2ee",
".W c #bdd6e6",
"#t c #bddaf6",
"#k c #bddef6",
".L c #bddeff",
".7 c #bde2ff",
"#F c #c5daee",
"#L c #c5daf6",
".o c #c5e2ff",
".P c #c5e6ff",
"#4 c #cddee6",
"#3 c #cddef6",
"ac c #cddeff",
".8 c #cde6ff",
".A c #cdeaff",
"#V c #d5deee",
"#U c #d5e2e6",
"#J c #d5e2ee",
"#q c #d5e2f6",
".G c #d5e6ff",
".y c #d5eaff",
".4 c #dee2e6",
"#T c #dee2ee",
"#K c #dee6ee",
"ad c #dee6f6",
".9 c #deeaff",
"#A c #e6eaee",
"#S c #e6eaf6",
"#f c #e6eef6",
".3 c #e6eeff",
".Q c #e6f2ff",
"#x c #eeeef6",
".V c #eef2f6",
".p c #eef2ff",
"#r c #eef6f6",
".s c #eef6ff",
".z c #eefaff",
".M c #f6f2f6",
"#G c #f6f2ff",
"#b c #f6f6f6",
"#j c #f6f6ff",
".q c #f6faff",
".U c #fffaff",
".r c #ffffff",
"Qt.#.a.b.c.d.e.f.g.h.i.jQtQtQtQtQt.k",
".#.l.m.n.o.p.q.r.r.s.o.t.u.vQtQtQt.k",
".a.w.x.y.r.r.z.A.r.r.r.s.B.C.DQtQt.k",
".E.F.G.r.r.r.H.H.r.r.r.r.q.I.J.DQt.k",
".K.L.q.r.M.N.O.P.r.r.r.r.r.Q.R.S.v.k",
".T.y.U.V.W.X.Y.r.r.r.U.r.r.r.Z.0.1.k",
".2.3.U.4.5.6.7.A.A.P.A.8.q.U.9#.##.k",
"#a.p#b#c#d#d#d#d#d#d#d#d#e.r#f#g#h.k",
"#i#f#j#k.6.6#l#m#l#m#l#m.A.U.3#n#o.k",
"#p#q#r.V#s.6.A.r.r.r.r.r.r#j#t#u#o.k",
"#v#w#x.V.Q#y#z.r.r.r.U#j.V#A#B#C#h.k",
"#D#E#F#G.V#H#d#I.U#f#J#K#J#L#M#N##.k",
"#O#P#Q#J#j#j#R#z.U#S#T#U#V#W#X#Y.1.k",
"#Z#0#1#2#3#j.q.r.V#K#4#5#6#7#8#9.v.k",
"a.a..Da#aaabacad#qaeafagah#8ai.DQt.k",
"QtajQt.Dakalamanaoapaqar#Y#9.DQtQt.k",
"QtQtQtQt.v.1###h#o#o#h##.1.vQtQtQt.k",
".k.k.k.k.k.k.k.k.k.k.k.k.k.k.k.k.k.k"};

static const char* const a_0_data[] = { 
"40 40 88 2",
"Qt c None",
"#l c #000000",
"#h c #200000",
"#k c #310000",
".7 c #4a0000",
"#s c #4a0010",
"#p c #521000",
".4 c #521010",
".9 c #523039",
".S c #620800",
"#o c #620810",
".Z c #621010",
"#u c #622029",
".0 c #731000",
".5 c #731010",
".6 c #7b1010",
".O c #8b3039",
"#b c #8b616a",
".1 c #941000",
".P c #941010",
".T c #941029",
".Q c #941810",
"#. c #941829",
".A c #9c1029",
".V c #9c1810",
".K c #9c2010",
".U c #a42029",
".8 c #ac1810",
".B c #ac2010",
".W c #ac2029",
".n c #ac5952",
"#j c #ac9d94",
".R c #bd2010",
".o c #bd2029",
".2 c #bd3029",
"#n c #bd8d7b",
"#g c #bdb6bd",
"#d c #cd2010",
".w c #cd2029",
"#e c #cd2839",
".u c #cd3029",
".J c #cdaeac",
".3 c #d53839",
".g c #de2029",
"## c #de2839",
".p c #de3029",
".j c #de3039",
"#q c #de3829",
".C c #de3839",
".v c #de3852",
".X c #de4839",
".H c #de95ac",
".d c #de9dac",
".h c #deaeac",
"#r c #deb6bd",
".D c #debeac",
".x c #debebd",
".M c #decebd",
".E c #ded6d5",
".G c #dedeee",
"#f c #e6596a",
"#m c #e69594",
".s c #e69d94",
"#v c #e6ded5",
"#i c #e6e6ee",
".z c #ee2829",
".t c #ee2839",
".m c #ee3029",
".r c #ee3039",
".Y c #ee3829",
"#a c #ee3839",
".y c #ee3852",
".I c #ee4839",
".b c #ee5052",
".a c #ee6152",
".k c #ee616a",
".# c #ee717b",
".i c #ee797b",
".L c #ee957b",
".l c #ee9594",
".F c #eebebd",
".e c #eeded5",
"#c c #eee6d5",
".c c #eeeeee",
".f c #f6716a",
".q c #f6cebd",
"#t c #f6d6d5",
".N c #ff697b",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt.#.a.b.#.cQtQtQtQtQtQtQtQtQtQtQt.d.b.b.b.eQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt.f.g.b.d.h.i.b.jQtQtQtQtQtQtQtQt.#.b.k.l.h.f.m.gQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.n.o.p.f.h.c.e.b.m.m.qQtQtQtQtQt.g.g.r.s.c.e.l.b.m.tQtQtQtQtQtQtQt",
"QtQtQtQtQtQt.h.o.o.u.v.f.s.e.c.f.g.m.sQtQtQt.w.g.r.c.c.x.l.a.y.m.z.rQtQtQtQtQtQt",
"QtQtQtQtQtQt.A.B.B.o.C.k.i.D.E.c.F.p.g.eQt.w.g.k.c.G.x.H.#.b.I.m.r.z.G.xQtQtQtQt",
"QtQtQtQtQt.J.K.K.B.o.u.b.L.h.M.E.M.d.z.g.w.w.N.x.M.G.M.H.k.y.m.m.r.m.rQtQtQtQtQt",
"QtQtQtQtQt.O.P.Q.A.A.o.u.b.i.H.H.i.f.a.z.R.j.f.f.l.H.l.k.b.m.m.m.m.t.rQtQtQtQtQt",
"QtQtQtQtQt.S.T.P.K.U.V.W.o.p.k.a.a.b.y.m.R.u.X.b.b.k.y.Y.m.t.m.m.z.r.mQtQtQtQtQt",
"QtQtQtQtQt.Z.0.1.P.T.K.U.W.w.p.y.b.b.y.m.W.2.3.C.b.r.j.m.m.m.r.r.m.m.zQtQtQtQtQt",
"QtQtQtQtQt.4.5.P.6.P.U.V.o.W.w.p.b.b.b.m.W.u.C.b.p.j.z.r.m.z.m.t.m.r.mQtQtQtQtQt",
"QtQtQtQtQt.7.5.5.0.P.P.K.8.o.W.g.g.b.f.f.H.f.b.p.p.z.g.z.z.m.z.r.m.m.mQtQtQtQtQt",
"QtQtQtQtQt.9.S.5.5#..P.U.K.B.W.R.w.p.y.l.h.a.m##.g.p.z.z.z.r.r.m#a.r.mQtQtQtQtQt",
"QtQtQtQtQt#b.4.Z.6.P.Q.Q.8.W.W.R.R.w.w.g.p.w.g.p.g.g.m.z.m.r.m#a.b.m.mQtQtQtQtQt",
"QtQtQtQtQt#c.7.7.5.5.T.Q.U.8.W.W.o.o#d.w.w.g.g.g#e.z.g.m.m#a.I.b.b#a#fQtQtQtQtQt",
"QtQtQtQtQt#g#h.7.Z.5.P.P.A.K.W.B.o.o.o#d.w.g.g.g.g.t.j.r.I.y.a.f.a.m#iQtQtQtQtQt",
"QtQtQtQtQtQt#j#k.Z.Z.P.T.Q.U.B.o.B.w.o.w.w.w.w.p.g.p.r#a.b.f.i.s.k.pQtQtQtQtQtQt",
"QtQtQtQtQtQtQt#l.7.Z.5.P.Q.K.W.W.B.o.o.w.w.g.w.g.j.m.Y.b.f#m.h.d.y.eQtQtQtQtQtQt",
"QtQtQtQtQtQtQt#n#h.7.5.5.P.A.8.V.o.B.o.o.o.w.w.p.z#a.b.#.d.E.E.l.mQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt#h#k.S.5.6.P.V.W.W.B.R.o.w.w.u###a.b.i.h.c.c.M.m.cQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt#k.7#o.5.T.P.P.W.W.o.R.w.w.p.p.y.#.d.c.c.c.f#mQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.E#k#p.Z.5.P.V.U.V.W.o.o.w#q.y.f.d.G.c.c.d.bQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt#j.7#o.Z.6.P.Q.K.U.W.o.u.C.a.l#r.c.c#m.YQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt.M#p.5.Z.5.P.Q.A.B.W.u.X.k.H.D.M.f.bQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQt.e#s.5.6.6.1.Q.V.o.u.v.f#m.d.b.iQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQt#o.5.6.Q.P.U.W.p.b.#.L.b#tQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#b.5.6.P.K.W.j.f.f.YQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#u.6.A.2.f.Y.eQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#v.5.p.dQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const a_1_data[] = { 
"40 40 93 2",
"Qt c None",
"#i c #200000",
"#k c #310000",
"## c #4a0000",
"#b c #4a0010",
"#h c #521000",
"#r c #521010",
"#t c #620800",
"#o c #620810",
".4 c #621010",
"#y c #622029",
".7 c #6a0800",
"#p c #6a0810",
".Y c #731000",
".8 c #731010",
"#e c #735952",
".Z c #7b1010",
"#f c #7b1029",
"#q c #941000",
".V c #941010",
"#c c #941029",
".0 c #941810",
".U c #941829",
"#w c #945952",
".1 c #9c1029",
".Q c #9c1810",
".H c #9c2010",
"#d c #a42029",
".C c #ac1829",
".J c #ac2010",
".I c #ac2029",
".P c #ac9d94",
".3 c #bd2010",
".s c #bd2029",
".5 c #bd3029",
".r c #bdb6bd",
"#a c #cd2010",
".t c #cd2029",
"#j c #cd2810",
"#s c #cd2839",
".D c #cd3029",
".j c #cd3039",
"#z c #cdaeac",
".6 c #d53829",
".G c #de2029",
".q c #de2839",
".u c #de3029",
".9 c #de3039",
"#x c #de3829",
".K c #de3839",
".i c #de3852",
"#. c #de4839",
".2 c #de5052",
".B c #de796a",
".W c #de95ac",
".E c #de9dac",
".l c #deaeac",
".h c #debebd",
".T c #decebd",
".S c #ded6d5",
"#n c #dedeee",
".m c #e6596a",
"#A c #e6716a",
".N c #e69594",
".A c #e69d94",
".d c #e6a5ac",
"#u c #e6ae94",
".L c #e6ded5",
".# c #e6e6ee",
".x c #ee2829",
".O c #ee2839",
".p c #ee3029",
".n c #ee3039",
".z c #ee3829",
"#g c #ee3839",
".g c #ee3852",
".w c #ee4839",
".b c #ee5052",
".c c #ee6152",
".a c #ee616a",
".f c #ee717b",
".R c #ee797b",
".X c #ee957b",
".o c #ee9594",
"#v c #eeaeac",
".e c #eebebd",
".M c #eeded5",
".y c #eee6d5",
".v c #eeeeee",
"#l c #f6596a",
".k c #f6716a",
"#m c #f6cebd",
".F c #f6d6d5",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.#.a.b.c.dQtQtQtQtQtQtQtQtQtQtQtQt.e.f.g.g.e.hQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt.i.j.k.l.l.k.g.mQtQtQtQtQtQtQtQt.h.n.c.o.l.o.p.q.#.hQtQtQtQtQtQt",
"QtQtQtQtQt.rQt.s.t.u.k.h.v.h.w.p.x.yQtQtQtQtQt.i.u.z.f.v.v.A.g.p.x.vQtQtQtQtQtQt",
"QtQtQtQtQtQt.B.C.s.D.i.k.E.v.v.a.p.x.FQtQtQt.t.G.n.e.v.h.o.b.b.p.p.n.hQtQtQtQtQt",
"QtQtQtQt.rQt.H.I.J.s.K.c.f.E.L.v.E.G.G.vQt.D.G.c.v.M.h.N.f.b.n.p.p.O.AQtQtQtQtQt",
"QtQtQtQtQt.P.Q.H.J.I.D.g.R.E.S.h.S.l.x.t.G.t.a.T.T.S.l.o.c.g.z.n.n.p.nQtQtQtQtQt",
"QtQtQtQtQt.U.V.Q.Q.J.I.s.b.k.W.E.o.k.c.x.t.D.k.X.o.E.o.c.b.p.p.n.x.p.pQtQtQtQtQt",
"QtQtQtQtQt.Y.Z.V.U.0.1.I.s.2.a.c.a.b.b.n.3.j.2.g.c.c.g.z.O.n.p.O.p.p.n.vQtQtQtQt",
"QtQtQtQtQt.4.Z.V.0.V.H.J.I.s.u.b.b.b.p.n.I.5.6.b.b.n.n.x.x.p.p.x.p.p.n.MQtQtQtQt",
"QtQtQtQtQt.7.8.Z.V.0.0.H.J.I.t.u.b.g.w.p.I.j.9#..i.p.G.p.O.p.n.p.p.p.p.vQtQtQtQt",
"QtQtQtQtQt##.8.8.Z.V.V.Q.J.s.I#a.u.b.k.b.k.2.c.n.G.u.x.p.x.n.p.n.p.n.p.yQtQtQtQt",
"QtQtQtQtQt#b.Y.8.8.V#c#d.H.J.I.s.t.u.b.l.M.k.u.j.u.u.n.x.n.n.p.g.g.p.nQtQtQtQtQt",
"QtQtQtQtQt#e#b.7#f.V.V.U.1.J.s.I.3.t.t.G.u.u.G.G.G.G.G.p.n.p#g.b.z#g.pQtQtQtQtQt",
"QtQtQtQtQt.L###h.8.8.V.V.Q.C.I.3.s.s.t.s.t.t.u.G.u.q.x.n.p.g.b.b.b.b.wQtQtQtQtQt",
"QtQtQtQtQt.r#i##.4.Y#c.V.U.H.J.J.J.s.s.t#j.D.G.u.G.u.p#g.b.b.a.a.k.n.MQtQtQtQtQt",
"QtQtQtQtQtQt.P#k.4.4.8#c.0.H.J.I.3.3.t.t.t.G.t.G.u.n.p#g.c.f.o.N.a.GQtQtQtQtQtQt",
"QtQtQtQtQtQt.r#i#b.8.Y.V.0.0.H.C.I.s.3.t.t.D.t.u.9.n.b.c.X.E.l.E#l#mQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.P#k##.8.8.V.0.1.C.s.J.s.3.t.t.G.u.z.w.c.o.l.L#n.A.pQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt#i###o.8.8.V.U.H.C.I.s.s.t.t.q.9.b.c.W.h.v.v.M.b.vQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt#k#b#p.Y#q.V.H.Q.J.s.I.t.t.u#g.c.o.h.v.v.v.R.AQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.S###r.8.8.Z.0.1.1.I.J.s#s.K.b.k.l.v.v.v.A#lQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt.P#b#t.4.Z.0.0#d.I.J.I.D.K.c.X.T.v.v#u.pQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt.S##.8#t.Z#q.H.1.I.s.j#..k.W.S.S.N.2QtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQt.L#r.8.8.Z.U.H.J.I.D.g.k.l.h.k.RQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQt#b.8.8.V#c.I.I.i.b.o.E.a#vQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#w.8.8.0#d.I#x.f.X.g.rQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.L#y.Z.0.D.f.b.EQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#z.Z.u#AQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const a_2_data[] = { 
"40 40 89 2",
"Qt c None",
"#m c #200000",
"#i c #310000",
"#c c #4a0000",
"#e c #4a0010",
"#q c #521000",
"#f c #521010",
".9 c #620800",
".8 c #621010",
"#j c #622029",
".Y c #731000",
".R c #731010",
"#n c #735952",
"#. c #7b1010",
".2 c #7b1029",
".N c #8b3039",
"#u c #8b616a",
".Z c #941000",
".S c #941010",
".3 c #941029",
".T c #941810",
".0 c #941829",
"#w c #945952",
"## c #9c1029",
".O c #9c1810",
".U c #9c2010",
".I c #a42029",
"#g c #ac1810",
"#a c #ac1829",
".5 c #ac2010",
".B c #ac2029",
"#h c #ac9d94",
".V c #bd2010",
".r c #bd2029",
".W c #bd3029",
".6 c #bd3039",
"#l c #bdb6bd",
".h c #cd2029",
".y c #cd3029",
".7 c #cd3039",
"#v c #cdaeac",
".K c #de2029",
".E c #de2839",
".D c #de3029",
".s c #de3039",
".4 c #de3829",
"#t c #de3839",
".C c #de3852",
"#b c #de4839",
".L c #de5052",
".J c #de796a",
".P c #de95ac",
".# c #de9dac",
".k c #deaeac",
".F c #debeac",
".Q c #debebd",
".o c #decebd",
".j c #ded6d5",
"#o c #dedeee",
"#r c #dee6ee",
".x c #e6596a",
"#k c #e69594",
".w c #e69d94",
".q c #e6a5ac",
"#p c #e6ded5",
".A c #ee2829",
".p c #ee2839",
".a c #ee3029",
".n c #ee3039",
".i c #ee3829",
".X c #ee3839",
".H c #ee3852",
".c c #ee4839",
".b c #ee5052",
".f c #ee6152",
".z c #ee616a",
".g c #ee717b",
".t c #ee797b",
".G c #ee8d94",
".M c #ee957b",
".d c #ee9594",
".1 c #eeaeac",
".e c #eebebd",
".m c #eeded5",
"#d c #eee6d5",
".v c #eeeeee",
".l c #f6716a",
"#s c #f6cebd",
".u c #f6d6d5",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.#.a.b.c.dQtQtQtQtQtQtQtQtQtQtQtQt.e.f.b.a.gQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt.h.i.d.j.k.g.b.lQtQtQtQtQtQtQtQt.m.n.l.d.o.#.b.p.qQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.r.h.s.t.u.v.w.i.n.pQtQtQtQtQtQt.x.y.n.z.v.v.#.z.a.A.qQtQtQtQtQtQt",
"QtQtQtQtQtQt.B.r.B.y.C.f.w.v.v.i.D.pQtQtQtQt.C.D.E.w.v.F.G.z.H.i.p.AQtQtQtQtQtQt",
"QtQtQtQtQt.u.I.B.B.r.C.b.l.#.j.v.J.K.AQtQt.L.h.D.v.m.k.M.l.b.n.n.a.A.HQtQtQtQtQt",
"QtQtQtQtQt.N.O.O.I.B.h.C.g.P.k.Q.o.w.D.h.L.h.z.o.o.Q.k.M.z.b.n.a.A.a.aQtQtQtQtQt",
"QtQtQtQtQt.R.S.T.U.U.V.W.L.l.d.#.d.t.f.A.h.D.g.d.P.P.d.f.H.X.a.p.n.p.n.vQtQtQtQt",
"QtQtQtQtQt.Y.Z.S.0.T.U.B.r.L.f.z.f.f.b.a.r.y.b.f.z.l.H.X.a.A.n.n.a.a.n.1QtQtQtQt",
"QtQtQtQtQt.R.Z.2.T.3.O.O.B.r.4.b.b.H.c.a.5.6.7.H.b.X.a.a.A.A.a.a.p.a.a.dQtQtQtQt",
"QtQtQtQtQt.8.R.S.0.T.U.O.5.B.h.D.b.b.H.i.r.y.D.b.s.n.A.n.A.a.n.a.a.n.a.dQtQtQtQt",
"QtQtQtQtQt.9.R#..S.0.T###a.B.5.h.a.f.b.c.C#b.f.X.D.D.K.n.a.a.a.a.n.n.a.1QtQtQtQt",
"QtQtQtQtQt#c.Y.R.Y.U.S.I.I.5.r.r.h.D.f.o.v.M.i.D.K.K.a.A.a.a.X.n.X.X.a#dQtQtQtQt",
"QtQtQtQtQt#e#f.8.Y.Z.T.T.U#g.5.B.h.h.h.a.s.K.D.K.D.A.E.a.a.X.n.c.i.c.aQtQtQtQtQt",
"QtQtQtQtQt#h#c.9.R.S.T.0.S.U.B.V.r.r.r.h.h.K.K.K.K.D.a.n.H.i.b.b.f.b.AQtQtQtQtQt",
"QtQtQtQtQtQt#i#c.R#..S.T.T.U.5.5.5.r.r.h.h.h.D.K.D.a.X.c.b.b.z.z.g.b.qQtQtQtQtQt",
"QtQtQtQtQtQt#j#c.8.R#..S.S.S##.B.V.5.h.h.h.h.h.D.D.a.X.b.z.l.M#k.t.aQtQtQtQtQtQt",
"QtQtQtQtQtQt#l#m#f.R.R.3.S.T.U.B.B.V.r.h.h.h.D.D.a.H.b.z.d#k.k.k.l.d#lQtQtQtQtQt",
"QtQtQtQtQtQtQt#n#c.8.9#..S.S.U##.5.B.V.r.h.h.D.D.X.b.l.d.k.j#o.k.aQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt#m#c.R.Y.S.S.0.U.5.5.B.r.h.h.D.X.H.l#k.k#p.v.v.z.mQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt#o#i#q.R.R#..S.3.U#g.B.B.r.h.D.c.f.d.k#r.v.v.k.fQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt#h#e#q.R.R.Z.T.I##.5.r.r.D.s.b.l.##p.v.v#s.HQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt#n#e.8.8.S.S.S###a.5.r.y#t.f.t.F.v.v#s.nQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt#u#c.Y.R.S.3.O.U.B.B.y.L.z#k.j#d.Q.aQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQt#l#f.R.Y.S.U.O.5.r.y.H.l.#.j.#.LQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQt#p#e.R.R.S.U.I.B.y.f.d.k#k.tQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.8.R.R##.I.r.4.g#k.b.uQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#v.9.S.I.h.l.l.zQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#w#..y.H.vQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.uQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const a_3_data[] = { 
"40 40 89 2",
"Qt c None",
"#m c #200000",
"#o c #310000",
"#i c #4a0000",
"#g c #4a0010",
"#r c #521010",
"#k c #523039",
"#l c #620800",
"#. c #621010",
"#v c #622029",
"#p c #6a0810",
".5 c #731000",
".0 c #731010",
".6 c #7b1010",
"#b c #7b1029",
"#u c #7b2829",
"#s c #941000",
".V c #941010",
".W c #941029",
".7 c #941810",
".4 c #941829",
"#j c #9c1029",
".8 c #9c1810",
".O c #9c2010",
".X c #a42029",
"#c c #ac1810",
".P c #ac1829",
".Q c #ac2010",
".M c #ac2029",
"#n c #ac9d94",
"## c #b42839",
"#d c #bd2010",
".D c #bd2029",
"#e c #bd3039",
".N c #bd8d7b",
".# c #bdb6bd",
"#t c #cd2010",
".w c #cd2029",
".E c #cd3029",
".1 c #cd3039",
".S c #cdaeac",
".I c #de2029",
"#a c #de2839",
".k c #de3029",
".u c #de3039",
".9 c #de3839",
".F c #de3852",
"#f c #de4839",
".p c #de5052",
".v c #de796a",
".q c #de95ac",
".j c #de9dac",
".n c #deaeac",
".K c #deb6bd",
".l c #debeac",
".e c #debebd",
".r c #decebd",
".m c #ded6d5",
"#q c #dedeee",
".i c #e6596a",
".T c #e69594",
".B c #e69d94",
".R c #e6a5ac",
".G c #e6ded5",
".o c #e6e6ee",
".U c #ee2829",
".2 c #ee2839",
".C c #ee3029",
".t c #ee3039",
".Y c #ee3829",
".J c #ee3839",
".h c #ee3852",
".z c #ee4839",
".b c #ee5052",
".g c #ee6152",
".y c #ee616a",
".c c #ee717b",
".L c #ee797b",
".Z c #ee8d94",
".a c #ee957b",
".f c #ee9594",
"#h c #eeaeac",
".3 c #eebebd",
".d c #eeded5",
".A c #eee6d5",
".x c #eeeeee",
".s c #f6716a",
"#w c #f6cebd",
".H c #f6d6d5",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.#QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.a.b.b.c.dQt.eQtQtQtQtQtQtQtQtQtQtQt.f.g.h.i.dQtQtQtQtQtQtQtQt",
"QtQtQtQtQt.#Qt.j.k.b.l.m.n.c.h.oQtQtQtQtQtQtQtQtQt.p.g.q.r.r.s.t.uQtQtQtQtQtQtQt",
"QtQtQtQtQtQt.v.w.u.s.n.x.d.y.z.t.cQtQtQtQtQtQt.A.u.t.b.B.x.x.B.b.t.CQtQtQtQtQtQt",
"QtQtQtQtQt.r.D.D.E.F.s.j.G.x.y.C.C.pQtQtQtQt.H.w.I.J.m.x.K.L.g.h.C.t.CQtQtQtQtQt",
"QtQtQtQtQt.M.M.M.D.E.b.y.f.n.x.n.k.I.LQtQt.x.I.I.y.x.r.q.c.y.b.t.C.C.C.HQtQtQtQt",
"QtQtQtQt.N.O.P.Q.M.E.F.s.c.q.n.e.r.C.I.RQt.w.w.f.l.S.j.T.s.b.h.J.C.U.C.UQtQtQtQt",
"QtQtQtQt.V.W.X.O.M.Q.k.b.s.T.T.f.j.a.Y.I.I.k.c.f.f.q.f.Z.s.b.C.t.C.C.C.tQtQtQtQt",
"QtQtQtQt.0.V.V.V.X.O.D.E.h.s.s.y.y.y.g.C.w.1.b.g.y.s.y.g.h.C.t.C.2.C.U.C.3QtQtQt",
"QtQtQtQt.0.V.4.W.O.X.M.M.w.k.b.b.b.h.z.t.D.E.u.p.b.b.b.h.t.2.C.C.t.2.C.C.TQtQtQt",
"QtQtQtQt.5.6.W.7.W.8.M.D.D.w.k.h.b.Y.J.t.M.E.k.9.z.9.C.I.C.t.U.U.C.t.C.t.cQtQtQt",
"QtQtQtQt#..0.6.V.7.8.O.M.M.Q.w.u.b.h.Y.t.D##.E.9.k.k.k#a.C.U.C.t.U.C.C.t.cQtQtQt",
"QtQtQtQt.5.0#b.6.4.8#c.M.Q#d.D.I.C.b.h.h#e.k.F#f.C.k.U.U.U.t.C.t.C.t.t.C.LQtQtQt",
"QtQtQtQt#g.5.0.V.7.7.8.X.Q.M.D.w.I.z.s.R.x.L.b.w.I.k#a.U.C.U.t.t.Y.Y.h.t#hQtQtQt",
"QtQtQtQt#i#..0.6.W.7#j#c.Q.M.D#d.w.w.C.b.b.h.I.I.k.I.I.U.2.t.C.J.z.z.C.t.dQtQtQt",
"QtQtQtQt#k#i#l.6.7.W.8.8.M.M.Q.D.D.w.w.w.I.w.E.I.I.k.C.U.C.t.t.z.h.b.b.UQtQtQtQt",
"QtQtQtQt.m#i#..0.5.7.4.O.O.Q.Q.M.D.w.Q.w.w.w.I.k.k.I.k.C.h.Y.b.b.g.s.b.bQtQtQtQt",
"QtQtQtQt.##m#i.0.0.V.7.V#j.P.M.M#d.D.D.w.w.w.w.I.k.k.t.z.b.b.b.c.s.c.h.xQtQtQtQt",
"QtQtQtQtQt#n#o#p.0.V.V.4.8.X#c#d.M.D#d.w.w.w.I.I.k.t.t.z.b.y.s.T.j.a.kQtQtQtQtQt",
"QtQtQtQtQtQt#m#i#..6.V.W.O#j.Q.M.M.Q.D#d.w.w.k.I.k.J.b.b.y.a.f.n.l.b.dQtQtQtQtQt",
"QtQtQtQtQtQt.##o#.#..V.W.7.8.M.Q.Q.D.Q.w.w.E.I.k.u.Y.b.s.f.j.r#q.n.CQtQtQtQtQtQt",
"QtQtQtQtQtQtQt#o#g#..6.6.7.O#j.P.P.Q.Q.D.w.w.E.k.J.b.y.a.j.G.x.A.zQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt#o#i#..6.4.V.7.O#c.Q.M.D.D.E.u.F.h.g.L.j#q.x.x.f#hQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt.G#r#r#l#s.W.4#j.P.Q.M.Q#t.1.k.k.b.c.f.m.x.x.R.LQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.m#i#..0.0.V.V.O#c.M.D.D.E.k.b.g.a.l.x.x.j.pQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt.G#r#p#.#s.V#j.8.Q.M.D.w.k.b.s.j.G#q.f.sQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQt#i.0.0.6.W.O.Q.D.M.E#f.g.T.n.r.y.nQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQt#r.0.0.V.4.8.M.M.1.h.s.q.j.b.oQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQt#n#..0.V.O.Q.M.E.g.a.s.bQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#u.6.V.8.D.b.s.h.HQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#v.8##.h.3QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.A#wQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const a_4_data[] = { 
"40 40 198 2",
"Qt c None",
"aN c #200000",
"aJ c #290000",
"aC c #310000",
"aL c #311829",
"aM c #4a0000",
"aY c #4a0010",
"ay c #4a0800",
"aT c #520800",
"a5 c #521000",
"aK c #521010",
"aP c #523039",
"as c #5a0800",
"aD c #5a0810",
"aU c #5a1010",
"aZ c #620800",
"an c #620810",
"az c #621010",
"ac c #622029",
"aG c #6a0800",
"aQ c #6a0810",
"ai c #6a1000",
"at c #6a1010",
"ad c #731000",
"ao c #731010",
"aF c #735952",
"#X c #7b1010",
"#K c #7b1029",
"ae c #7b1810",
"b. c #7b2829",
"#7 c #8b1010",
"aj c #8b1810",
"ba c #8b3039",
"ah c #8b5952",
"am c #8b596a",
"a1 c #8b616a",
"#8 c #941000",
"#L c #941010",
"#Y c #941029",
"#s c #941810",
"#M c #941829",
"a8 c #945952",
"aO c #9c1029",
"#A c #9c1810",
"#0 c #9c1829",
"#Z c #9c2010",
"#W c #9c6152",
".8 c #a41810",
"ak c #a41829",
"#t c #a42010",
"#9 c #a42029",
"aA c #ac1810",
"af c #ac1829",
"#j c #ac2010",
"a. c #ac2029",
"bc c #ac5952",
"aX c #ac9d94",
"ag c #b42010",
".R c #b42029",
"#k c #b42839",
"au c #bd2010",
".S c #bd2029",
"a2 c #bd2810",
"#O c #bd2829",
"#B c #bd3029",
"a9 c #bd3039",
"#i c #bd8d7b",
"ar c #bdb6bd",
"aH c #cd2010",
".F c #cd2029",
"aE c #cd2810",
"#1 c #cd2829",
"#4 c #cd2839",
".9 c #cd3029",
".T c #cd3039",
"#J c #cdaeac",
"#d c #d52029",
"aI c #d52810",
"#w c #d52829",
"#2 c #d52839",
"aV c #d53029",
"#F c #d53039",
"#l c #d53829",
"#. c #d53839",
".2 c #de2029",
".n c #de2829",
"aq c #de2839",
".G c #de3029",
"#C c #de3039",
"a3 c #de3829",
"#N c #de3839",
"a6 c #de3852",
"al c #de4839",
".D c #de4852",
".7 c #de5052",
"aB c #de796a",
"#c c #de95ac",
".s c #de9dac",
".E c #dea5ac",
".W c #deaeac",
"#o c #deb6ac",
".z c #deb6bd",
"aS c #debeac",
".M c #debebd",
".B c #decebd",
".r c #ded6d5",
"aR c #dedeee",
"#f c #dee6ee",
"#v c #e62029",
".Z c #e62829",
"#6 c #e62839",
".C c #e63029",
"#5 c #e63039",
"ax c #e63829",
".P c #e63839",
"#P c #e64839",
"#m c #e64852",
"b# c #e65052",
".L c #e6596a",
".# c #e6696a",
"#I c #e6716a",
"#p c #e68d94",
".e c #e69594",
".v c #e69d94",
".1 c #e6a5ac",
".p c #e6ae94",
".m c #e6aeac",
"ap c #e6bebd",
".3 c #e6cebd",
".I c #e6ded5",
".A c #e6e6ee",
"#U c #ee2829",
".0 c #ee2839",
"#T c #ee3029",
".O c #ee3039",
"#S c #ee3829",
".k c #ee3839",
".x c #ee3852",
"#3 c #ee4839",
"#Q c #ee4852",
"#D c #ee5052",
"## c #ee5952",
"aW c #ee6152",
"#e c #ee616a",
"av c #ee717b",
".b c #ee797b",
".N c #ee8d7b",
".h c #ee8d94",
".i c #ee957b",
".c c #ee9594",
"a7 c #eeaeac",
".f c #eebebd",
".Q c #eeded5",
"bd c #eee6d5",
".q c #eeeeee",
"#r c #f62829",
"aa c #f62839",
"#h c #f63029",
"#V c #f63039",
"a# c #f63829",
"#H c #f63839",
".a c #f63852",
"#R c #f64839",
"#u c #f64852",
"#G c #f65052",
".g c #f6596a",
".Y c #f6696a",
"#q c #f6716a",
".4 c #f6717b",
"#n c #f6797b",
".V c #f68d7b",
"bb c #f6cebd",
".l c #f6d6d5",
".w c #f6eeee",
"#z c #f6f6ee",
".X c #f6f6ff",
"a0 c #f6ffee",
"ab c #ff2829",
"#y c #ff2839",
".5 c #ff3029",
".6 c #ff3039",
"aw c #ff3829",
".K c #ff3839",
".J c #ff4839",
".u c #ff4852",
".o c #ff5052",
".j c #ff5952",
"#E c #ff596a",
".d c #ff6152",
".U c #ff616a",
".y c #ff6952",
"#a c #ff696a",
".t c #ff697b",
"#x c #ff716a",
"#g c #ff717b",
"#b c #ff796a",
"a4 c #ff797b",
".H c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt.#.a.b.c.d.eQtQtQtQtQtQtQtQtQtQtQtQt.f.g.h.i.j.k.lQtQtQtQtQtQtQt",
"QtQtQtQtQtQt.m.n.o.p.q.r.s.t.u.vQtQtQtQtQtQtQtQt.w.x.y.e.z.A.B.y.C.DQtQtQtQtQtQt",
"QtQtQtQtQt.E.F.G.d.s.q.H.I.y.J.K.LQtQtQtQtQtQt.f.G.k.o.E.H.H.M.N.u.O.PQtQtQtQtQt",
"QtQtQtQt.Q.R.S.T.D.U.V.W.q.X.Y.Z.0.OQtQtQtQt.1.2.n.k.3.X.B.v.4.j.u.5.6.7QtQtQtQt",
"QtQtQtQt.8.R.R.9#.###a#b#c.z.q.m.G.C.7QtQt.l#d.2#e#f.B.E.i#g.U.o.J.6.5#h.QQtQtQt",
"QtQtQt#i.8#j.R#k#l#m#a#n.e.e.s.W#o.k.n.7.Q#d.n#p#o.E.s.e.h#q.U.u.K.6#h.5#rQtQtQt",
"QtQtQt#s.8#t#t.R.T.D.d#a#n.N.b#b#n#b#u.n#v#w#a#a#x#n.N.N.4#a.o.J.5#h#h#y.5#zQtQt",
"QtQtQt#s#A.8.8#t.R#B#C#D#E.U.d.j.o.o.o.6.F#F#m#D#G.j.d.U.j.u.K#H#h#r.5.6.6#IQtQt",
"QtQt#J#K#L#s#M.8#j.R.F#C#N#u.u.u.J#H.K.K#O.T#N#C#P#Q#Q#R#S.O#T#U#V#U#r.5.5.OQtQt",
"QtQt#W#X#L#Y#Z#0#j.R.S#1#2#N#H#H#3.k#V#h.R#B#4#C#N#C#5#5.O#6#U.0#T#V.5.5.5#VQtQt",
"QtQt#W#X#7#8#s#t#9a..R.R#1#w.Pa##S.k#h.O.R#O#1#F#C.G.G#6.Z#T#U#U#Uaa#h.6.5abQtQt",
"QtQtacadae#7#s#Aafa.ag.R.F#d.n.k.a.aa##h#O#O.9#.#N.G#C.C.Z#U#U#U#Uaa#h.6#y#hQtQt",
"QtQtahai#Kaj#s#tak#j.R.R.S#1#w#C#H.u.J.K.9#1#Nal.G.G.n.n.Z.Z#T.0aa#h#h.6.6aaQtQt",
"QtQtamanao#X#s#A.8aga..R.R.S#1#w.G#R.U.vap#a#m#Caq.n.n.Z.n.C.0#U#V#V.6.6.6#rQtQt",
"QtQtarasat#X#s#0.8#t#j.R.Rau.S#1#1.G#Q.dav#Qaq#C.n.naq.C#v#5#T#V#Vaw.J.K.6axQtQt",
"QtQtQtayazaoaj#s#AakaA#j.R.Rau.S.F#w#2.n.naq#w#w.n.n.n.Z.Z#U#T.O#H.J.J.u.KaBQtQt",
"QtQtQtaCaDat#7#s#0#t.8af.Rag.Rau.S.FaE.F#d#d.2#w.n.n.n.Z#6#T.O#H.J.u.j.j#V.wQtQt",
"QtQtQtaFayaG#X#s#s#Zakafa..R.R.Rau.FaH.FaI#d#d#w.n.n.n#6.O.O#H.J.o.d.t#E.ZQtQtQt",
"QtQtQtQtaJaKao#7#s#0akafafag.Rau.Rau.S#1#w#d#d#d.n.n.n#5#T#H#u.o#a#n.e.j.NQtQtQt",
"QtQtQtQtaLaMaiao#L#s#tak#j.R.Rag.S.S.FaH#w#w#d.n.n.n.G#T.k.J.o#a#p.s.e.OQtQtQtQt",
"QtQtQtQt.waNasataj#saO.8afaA.R.Rag.S.F.FaE.F.2#w.n#C#5.x.J.o#a#p.W.z#q#IQtQtQtQt",
"QtQtQtQtQtaPayaQ#Xaj#s#0.8aAa..Ragau.F.S.F#1#daq.n.G.k#R.o#a.i#oaRaS.kQtQtQtQtQt",
"QtQtQtQtQtQtaJaTai#X#L#AakaA#j.R.Rau.S.S.F#w#w#2.G#5.k.o#a.V#o.X#z.Y.lQtQtQtQtQt",
"QtQtQtQtQtQt.AaCaUai#7#L#Z.8a.#j.R.Rau.S.F#1#waV#C#3#u.U.e.M#z.H.1aWQtQtQtQtQtQt",
"QtQtQtQtQtQtQtaXaYaZao#7#s#A#t#ta..R.Rau.S#w#w.G#P.J.y.V#oa0.H.3#HQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQta1aYaGaoaj#Y#0.8a.agag.Ra2#1#wa3#Q.da4.W#z.Hap#VQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtaXa5aiaoaj#s#0#t#j.Rag.S#1.Ga6#G.4.saR.q.1.kQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt.raUataoaj#L#0.8#j.R.S#1aV#m.d.i#o.Mav##QtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtaUataoaj#s#A.8.R.R.9#F#Q.t#c.v.oa7QtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQta8ad#X#X#s#0a..Ra9#NaW.4.d#TQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQt#zb.#X#7#M#9.RaVb#.j.0apQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt#zba#7#A.R#m.PbbQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtbc#FbdQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};


static const char* const p_icon_data[] = {
"16 15 164 2",
"ax c None",
"aH c None",
"ao c None",
"an c None",
"ag c None",
"af c None",
"am c None",
".e c None",
".n c None",
"#2 c None",
"ae c None",
"#T c None",
"#H c None",
".# c None",
".o c None",
"Qt c None",
"#3 c #000000",
".a c #eececd",
"#A c #6a2429",
"ap c #080000",
"#I c #6a595a",
"ay c #311010",
".m c #bd5962",
".d c #dec2cd",
"aw c #9c9dc5",
".D c #9c8594",
"aG c #acaed5",
".b c #f6ced5",
".c c #ffe6ee",
".f c #ee99a4",
"#4 c #733839",
"ah c #7b3839",
"#S c #9ca1cd",
".E c #ffb6b4",
"#U c #ac696a",
"aq c #833c39",
"#1 c #cdd2ff",
".P c #945d62",
".p c #ffbabd",
"az c #7b3031",
"al c #bdc2de",
"aC c #f6f2ff",
"aD c #f6f6ff",
"ad c #b4bade",
".l c #e66162",
"#B c #bd696a",
"aE c #d5daff",
"aF c #d5d6f6",
"aB c #c58da4",
".u c #dea1a4",
"av c #fffaff",
".g c #f6d2de",
"ai c #ac4041",
".C c #de5d62",
"ar c #9c3831",
".q c #f6cecd",
"#5 c #b4484a",
"aA c #943c41",
"#V c #c54c4a",
".t c #f6cecd",
"#J c #d54041",
".r c #f6d2d5",
".v c #f6c2c5",
".s c #f6d2d5",
".Q c #f68183",
".k c #f6b2bd",
"aj c #d55052",
".F c #ffb2b4",
".h c #f6e6ee",
"#R c #a4baf6",
"#Q c #acbeff",
"#9 c #b4c2f6",
"#m c #b4c6f6",
"#0 c #b4c6ff",
"#G c #bdaed5",
"#Y c #bdc2e6",
"#F c #bdcaff",
"ak c #bdceff",
"#q c #c5484a",
"a# c #c5ceee",
"#Z c #c5ceff",
"ac c #c5d2ff",
"#o c #cdd6ee",
"#n c #cdd6f6",
"#v c #cdd6ff",
"#8 c #d5bade",
"#W c #d5daff",
"au c #d5deff",
"#M c #d5e6ff",
"#z c #de5562",
"#y c #decee6",
"#D c #ded6ee",
"aa c #dedeee",
"#N c #dee2ff",
"a. c #dee6ff",
"#r c #e63c39",
"as c #e67983",
"#X c #e67d94",
"#p c #e691ac",
"#P c #e6e2ff",
"ab c #e6eaff",
"#E c #eeeeff",
"#O c #eef2ff",
"#t c #eef6ff",
"#C c #f63839",
"#l c #f6aebd",
"#u c #f6f6ff",
"#f c #ff3031",
"#e c #ff3431",
"#7 c #ff3439",
".6 c #ff3839",
"#6 c #ff3c41",
".7 c #ff4441",
".Z c #ff444a",
".Y c #ff484a",
"#d c #ff4c4a",
"#K c #ff4c52",
"#L c #ff5052",
"#c c #ff555a",
".0 c #ff595a",
"#g c #ff5d5a",
"#b c #ff6562",
"#s c #ff656a",
"#h c #ff696a",
".8 c #ff6d6a",
".O c #ff6d73",
"#i c #ff7173",
".9 c #ff7573",
".X c #ff757b",
"#a c #ff797b",
"#j c #ff7d83",
".R c #ff8183",
"#k c #ff8583",
".1 c #ff858b",
".S c #ff898b",
"#. c #ff9194",
".2 c #ff9594",
".B c #ff959c",
".W c #ff999c",
".N c #ff9d9c",
".T c #ff9da4",
"## c #ffa1a4",
".3 c #ffa5ac",
".G c #ffaaac",
".H c #ffaeac",
".A c #ffb2b4",
".5 c #ffb6b4",
".4 c #ffb6bd",
".M c #ffbabd",
".I c #ffbebd",
".z c #ffbec5",
".U c #ffc6c5",
".V c #ffc6cd",
".J c #ffcacd",
".y c #ffcecd",
".j c #ffd2d5",
".K c #ffd6de",
".L c #ffdee6",
".i c #ffe2e6",
".x c #ffe6e6",
".w c #ffeeee",
"at c #fff6ff",
"#x c #fffaff",
"#w c #ffffff",
"Qt.#.a.b.c.d.e.f.g.h.i.j.k.l.m.n",
".o.p.q.r.s.t.u.v.w.x.y.z.A.B.C.D",
".E.F.G.H.I.J.K.L.L.j.J.M.G.N.O.P",
".Q.R.S.T.H.I.U.J.U.V.M.A.W.X.Y.Z",
".0.X.1.2.3.H.4.M.M.5.3.S.O.Y.6.7",
".Z.8.9.1#..T##.3.N#.#a#b#c#d#e.Z",
"#f#g#h#i#j.R.1#k#l#m#n#o#p.7.Y#q",
"#r#d#g#s.8.9.X.0#t#u#v#w#x#y#z#A",
"#B#C#c.0#s#s.0#D#w#w#E#x#w#F#G#H",
"#I#J.7#K#L.0.0#M#N#x#O#P#N#Q#R#S",
"#T#U#V.Y.Y.Z#K#M#F#W#W#X#Y#Z#0#1",
"#2#3#4#5.Y#6#7#8#9#Fa.a#aaabacad",
"aeafagahaiaj.6.Yaka.#w#u#u#w#xal",
"#2amanaoapaqar.6asat#w#wau#wavaw",
"aeafagaoax#3ayazaAaBaCaDaEaFaGaH"};

static const char* const t_open_icon_data[] = {
"18 18 70 2",
"Qt c None",
".c c #000000",
".g c #00348b",
"#c c #00388b",
"#d c #003894",
".T c #0859b4",
".R c #0875bd",
".U c #1059bd",
".M c #1081cd",
".I c #1095d5",
".u c #10aae6",
".b c #1871e6",
".Q c #1875cd",
".D c #18a1e6",
".y c #2069c5",
".a c #2071e6",
".A c #2075cd",
".# c #2075e6",
".q c #2079cd",
".S c #2969c5",
".o c #2969cd",
".n c #297dcd",
".i c #2981cd",
".m c #2981d5",
".N c #29a1de",
".k c #3181cd",
".L c #3181d5",
".j c #3185d5",
".O c #31a5e6",
".K c #3981cd",
".G c #4191d5",
".z c #4a8dd5",
".P c #4a91d5",
".H c #4a95de",
".p c #5295d5",
".l c #5299d5",
".B c #529dde",
".F c #5a99de",
".h c #5a9dde",
".C c #5a9de6",
".V c #627db4",
".t c #62a5de",
".s c #62aae6",
".J c #62c2ee",
".r c #83bae6",
".E c #83d2f6",
".f c #94bee6",
".d c #94beee",
".e c #94c2ee",
".w c #9ce2f6",
".v c #a4e2f6",
".x c #a4e2ff",
".Y c #acbede",
".X c #acc2de",
".7 c #acc2e6",
".W c #b4c2de",
".6 c #b4c2e6",
".Z c #b4c6e6",
".0 c #bdcae6",
".8 c #bdceee",
".9 c #cdd6ee",
".1 c #cddaee",
".2 c #d5daee",
"#. c #d5def6",
".3 c #dee2f6",
".4 c #e6eef6",
"## c #eeeeff",
"#a c #f6f2ff",
".5 c #f6f6ff",
"#b c #fffaff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"Qt.#.a.#.b.c.cQtQtQtQtQtQtQtQtQtQtQt",
".#.d.e.f.e.g.c.cQtQtQtQtQtQtQtQtQtQt",
".a.h.i.j.k.j.i.j.k.j.i.j.g.cQtQtQtQt",
".#.l.m.n.o.o.o.o.o.o.o.o.o.o.o.o.o.c",
".b.p.q.o.r.s.t.s.t.s.t.s.u.v.w.x.y.c",
".#.z.A.o.h.B.h.B.C.B.h.B.D.E.E.E.o.c",
".a.z.y.F.G.H.G.H.G.H.G.H.I.J.J.o.c.c",
".#.K.o.F.L.i.L.i.L.i.L.i.M.N.O.o.cQt",
".b.o.P.A.Q.A.Q.A.Q.A.Q.A.R.M.S.cQtQt",
".#.o.T.T.U.T.T.T.U.T.T.T.U.T.o.cQtQt",
".a.V.W.X.Y.Z.0.1.2.3.4.5.5.o.c.cQtQt",
".#.Z.6.Z.7.Z.8.9#..3###a#b.o.c.cQtQt",
".g#c.g#d.g#c.g#d.g#c.g#d.g.c.cQtQtQt",
".c.c.c.c.c.c.c.c.c.c.c.c.c.cQtQtQtQt",
".c.c.c.c.c.c.c.c.c.c.c.c.c.cQtQtQtQt"};

static const char* const t_save_icon_data[] = { 
"16 17 64 1",
". c None",
"F c #000000",
"8 c #080810",
"E c #101418",
"2 c #181418",
"Q c #181818",
"S c #201c31",
"K c #292829",
"v c #313039",
"0 c #413c52",
"W c #4a4862",
"4 c #4a488b",
"e c #4a5562",
"6 c #525073",
"7 c #525573",
"a c #5a5962",
"c c #5a596a",
"5 c #5a599c",
"3 c #5a5d9c",
"# c #625d6a",
"i c #62616a",
"N c #62619c",
"L c #6a65a4",
"9 c #6a698b",
"U c #6a69a4",
"R c #7371ac",
"M c #7b75ac",
"V c #7b79b4",
"C c #7b7db4",
"w c #837db4",
"P c #8381bd",
"D c #8b85bd",
"I c #8b89bd",
"H c #9491c5",
"z c #9495c5",
"Y c #9c95c5",
"1 c #a4a5cd",
"Z c #acaacd",
"O c #acaad5",
"x c #b4aed5",
"r c #b4b6d5",
"y c #bdbade",
"l c #c5bede",
"m c #c5c2e6",
"j c #c5c6e6",
"s c #cdc6e6",
"q c #cdcee6",
"t c #d5cae6",
"h c #d5d2ee",
"u c #d5d6ee",
"n c #ded6ee",
"p c #dedaee",
"o c #dedaf6",
"g c #dedeee",
"A c #e6dae6",
"X c #e6def6",
"T c #e6e2ee",
"G c #e6e2f6",
"b c #e6e6f6",
"J c #e6eef6",
"d c #eee6f6",
"B c #eeeaf6",
"k c #fffaff",
"f c #ffffff",
"........#.......",
".......abc......",
"......#def#.....",
".....agefffc....",
"....#hifffff#...",
"...ajcfkfffffc..",
"..#lmj#fknonpq#.",
".arlasjcqtuppvwc",
"#xyadahz#bABvCDE",
"FmaGGbaHIcJKLMED",
"NFdGOGdaPCQRRED.",
".SFpTOGOaRUVEWF.",
"..FFXGYZQNVE0FFF",
"...FFO123VEFFFFF",
"....FFQ45E6FFFFF",
".....FFIE7FFFFFF",
"......F89FFFF..."};

static const char* const t_saveas_icon_data[] = { 
"18 18 93 2",
"Qt c None",
".o c #000000",
".L c #100c08",
".k c #181c18",
".n c #201c20",
".V c #202020",
".M c #291808",
".W c #312010",
"#a c #393c39",
".l c #413c41",
".m c #414041",
"#o c #414441",
"#t c #4a444a",
"#x c #525552",
".j c #5a3c20",
"#A c #5a555a",
"#s c #5a595a",
"#m c #5a5d5a",
"#f c #626162",
"#b c #626562",
".1 c #629da4",
".N c #6a3400",
".0 c #6a5041",
"#e c #6a656a",
"## c #6a696a",
"#d c #6a6d6a",
".H c #6aa5a4",
".I c #6aa5ac",
".X c #734429",
".2 c #736d73",
".U c #737173",
".K c #737573",
".G c #73a19c",
".c c #73e218",
"#c c #7b757b",
".z c #7b797b",
"#w c #7b7d7b",
".d c #7be620",
".3 c #837d83",
"#v c #838183",
"#q c #838583",
".a c #83e218",
".# c #83e620",
"#r c #8b858b",
"#l c #8b8d8b",
".g c #8be218",
".b c #8be620",
"#k c #949194",
".f c #94e218",
".Y c #9c654a",
".e c #9ce620",
".F c #a48562",
"#z c #aca5ac",
".J c #acbab4",
"#y c #b4b6b4",
".A c #bd5d00",
".Z c #bd7d62",
".7 c #bdb2ac",
"#u c #bdb6bd",
"#p c #bdbebd",
".8 c #c5bab4",
".6 c #c5babd",
".i c #cd814a",
".5 c #cdc6c5",
"#j c #cdcacd",
".E c #d59962",
".s c #d59d6a",
".t c #d59d7b",
"#i c #d5d2d5",
".R c #deaa8b",
".9 c #decec5",
"#n c #dedede",
".B c #e67500",
".u c #e6d2c5",
"#h c #e6dee6",
".O c #ee7d10",
".P c #ee8531",
".4 c #eee2e6",
"#g c #eee6ee",
".p c #f67908",
".Q c #f6a57b",
".r c #f6b673",
".D c #f6c27b",
".S c #f6dede",
"#. c #f6e6de",
".C c #ff9d31",
".q c #ffaa4a",
".h c #ffd6a4",
".T c #ffeade",
".y c #ffeee6",
".x c #fff2ee",
".w c #fff6f6",
".v c #fffaff",
"QtQt.#.a.b.c.d.cQtQt.e.f.e.g.b.gQtQt",
".h.i.j.k.l.m.m.m.m.m.m.m.k.n.o.oQtQt",
".p.q.r.s.t.u.v.w.w.x.x.y.m.z.n.o.oQt",
".o.A.B.C.D.E.F.G.H.I.J.y.m.K.k.o.oQt",
".o.L.M.N.O.P.Q.R.S.y.y.T.m.U.n.o.oQt",
".o.k.U.V.W.X.Y.Z.0.1.J.T.m.2.k.o.oQt",
"Qt.k.3.l.4.5.6.7.8.9#.#..m##.n.o.oQt",
"Qt.n.z.z#a.l#a.l#a.l.l.m#b##.k.o.oQt",
"Qt.k.z.K#c.U.U#d.2#####e#e#f.n.o.oQt",
"Qt.n.U.U#d.m.m.m.m.m.m.m#f#f.k.o.oQt",
"Qt.k.U.2.m#g#h#i#j.m#k#l.m#m.n.o.oQt",
"Qt.n####.m#n.m#o#p.m#q#r.m#s.k.o.oQt",
"Qt.k###e.m#i#t#e#u.m#v#w.m#x.n.o.oQt",
"Qt.n#b#b.m#j#p#y#z.m.K.K.m#A.k.o.oQt",
"Qt.o.n.k.n.m.m.m.m.k.n.k.n.k.o.o.oQt",
"Qt.o.o.o.o.o.o.o.o.o.o.o.o.o.o.o.oQt",
"QtQt.o.o.o.o.o.o.o.o.o.o.o.o.o.oQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const t_close_icon_data[] = { 
"16 16 76 2",
"Qt c None",
".# c #292c29",
".v c #313031",
".i c #313431",
"#h c #393839",
"#j c #181c18",
"#g c #201c20",
"#f c #202020",
"#i c #202420",
".w c #292429",
".h c #292829",
"#. c #292c29",
".a c #312c31",
".5 c #313031",
".2 c #313431",
".V c #393839",
".Q c #393c39",
".u c #414041",
".x c #4a484a",
".g c #4a4c4a",
".7 c #524c52",
".f c #525052",
".e c #525552",
".y c #5a555a",
".d c #5a595a",
".H c #5a5d5a",
".c c #625d62",
".z c #626162",
".b c #626562",
".A c #6a656a",
".I c #6a696a",
".W c #6a6d6a",
".B c #736d73",
".k c #737173",
".C c #737573",
".J c #7b797b",
".l c #7b7d7b",
".D c #837d83",
".E c #838183",
".n c #838583",
".m c #8b858b",
".F c #8b898b",
".o c #8b8d8b",
".6 c #948d94",
".p c #949194",
".q c #949594",
".O c #9c959c",
".r c #9c999c",
"#c c #9c9d9c",
".s c #a4a1a4",
".0 c #a4a5a4",
".K c #acaaac",
".3 c #acaeac",
".P c #b4aeb4",
".1 c #b4b2b4",
".4 c #b4b6b4",
".G c #bdb6bd",
".9 c #bdbebd",
".t c #c5bec5",
".8 c #c5c2c5",
"#d c #c5c6c5",
"#b c #cdc6cd",
"#a c #cdcacd",
".L c #cdcecd",
"#e c #d5ced5",
".N c #d5d6d5",
".R c #ded6de",
".j c #dedade",
".M c #dedede",
".U c #e6dee6",
".X c #e6e2e6",
".T c #e6e6e6",
".Y c #eee6ee",
".Z c #eeeaee",
"## c #eeeeee",
".S c #ffffff",
"Qt.#.a.b.c.d.d.e.f.f.f.g.f.h.iQt",
".#.c.j.k.l.m.n.o.o.p.q.r.s.t.u.v",
".a.j.w.x.y.d.z.A.B.C.D.E.F.o.G.h",
".z.E.x.H.H.I.I.k.J.D.E.F.o.q.K.u",
".c.l.y.z.j.L.C.J.E.E.M.N.O.r.P.Q",
".d.m.e.I.R.S.M.D.E.T.S.U.O.s.K.V",
".d.n.z.W.C.M.S.X.Y.S.Z.r.s.0.1.2",
".e.o.b.k.J.D.U.S.S.Y.O.s.s.3.4.5",
".f.6.B.J.E.E.Y.S.S.Z.s.s.K.4.t.a",
".7.p.k.D.E.T.S.Y.Y.S.Z.K.1.8.9#.",
".f.q.D.E.M.S.Z.r.s##.S##.9#a#b.w",
".x.r.D.F.T.U.O.s.s.K.Z.Z.8.N#a.w",
".f#c.F.p.O.r.s.s.K.1.9#d#e.M#a#f",
".h.t.F.q.r.s.0.3.4.8#a.N.j.S.J.h",
".i.u.G.K.P.K.1.4.t.8#b#b.U.J#g#h",
"Qt.v.w.u.V.V.2.5#.#.#i.w#j.h#hQt"};

static const char* const t_add_icon_data[] = { 
"18 18 9 1",
". c None",
"# c #000000",
"b c #008100",
"d c #00c200",
"f c #830000",
"g c #838100",
"c c #c50000",
"a c #c5ffc5",
"e c #ff0000",
"..................",
"........####......",
".......#ab###.....",
"......#cdbb###....",
".....#ecbbb###....",
"....#ebdcbbb###...",
"...eccbdbcdbb###..",
"..ecbdcdddbbb###..",
".ccbdaacbbdbbb###.",
".cfbgddacdbdbba###",
".ccf#dddaaddbab###",
".ec####dddadab####",
".ec#####dddab#####",
".ec#######ab#####.",
".#e###.#########..",
".#e###..#######...",
"..####....####....",
"..###............."};

static const char* const t_rescan_icon_data[] = { 
"18 18 152 2",
"Qt c None",
".U c #005900",
".e c #005d00",
".# c #006100",
"#T c #005900",
".d c #005d00",
"#f c #006100",
".a c #006500",
"ae c #005900",
".o c #005d00",
".f c #006100",
"#g c #005900",
".b c #005d00",
"#C c #005900",
".c c #005d00",
"aq c #005900",
".A c #005d00",
".p c #006100",
".n c #005d00",
"#8 c #006100",
".g c #006500",
".m c #006100",
"#e c #006500",
".h c #006900",
"av c #086908",
"ar c #086d08",
"#9 c #005d00",
".z c #006100",
".K c #006500",
".q c #006900",
".J c #006100",
".B c #006500",
"#t c #006d00",
".l c #007100",
".i c #007500",
"#h c #087508",
"as c #107910",
"au c #188118",
"#7 c #008500",
".V c #088108",
"#1 c #088508",
".r c #108510",
".5 c #188518",
".y c #188918",
"#L c #007500",
"#u c #007900",
"#D c #087908",
".j c #107910",
".k c #187d18",
"at c #188118",
"a. c #109d10",
"ak c #189d18",
".C c #209920",
".L c #209d20",
"af c #20a120",
".I c #39a139",
"#U c #00a100",
"#s c #00a500",
"#S c #00ae00",
"#B c #00b200",
"#K c #00b600",
"#J c #00be00",
"#A c #00c200",
"#V c #00ca00",
"#M c #08b208",
"#r c #08c208",
"#2 c #08c608",
"#N c #08ca08",
"#E c #10ba10",
"#6 c #10c610",
"#3 c #18d618",
"#d c #209d20",
"#F c #20ce20",
"al c #29aa29",
"a# c #29d629",
".6 c #31aa31",
"ap c #31ae31",
"#v c #31c231",
"ag c #31ce31",
"#i c #39ba39",
"ao c #39c239",
"aj c #39ce39",
"ah c #39da39",
"am c #41c241",
"an c #41ca41",
"ac c #41d641",
"aa c #41da41",
"ai c #41de41",
"#q c #4ace4a",
"#P c #4ad24a",
"#w c #4ad64a",
"#W c #4ada4a",
".s c #52ae52",
"#x c #52d252",
".x c #5aaa5a",
"#Q c #5ace5a",
"#c c #5ada5a",
"ad c #62e262",
"#p c #6ad26a",
"#j c #6ade6a",
"#I c #73d273",
".W c #73d673",
"#o c #73da73",
"#b c #73de73",
"#m c #73e273",
"#4 c #73e673",
".t c #7bca7b",
".4 c #7bd67b",
".7 c #7bde7b",
"#n c #83e283",
"#H c #83e683",
"ab c #83ea83",
".w c #8bce8b",
"#y c #8bd68b",
"## c #8be68b",
"#a c #8bea8b",
".D c #94de94",
"#l c #94ea94",
".v c #9cde9c",
"#5 c #9cea9c",
".u c #a4dea4",
".M c #a4e6a4",
".2 c #a4eaa4",
".X c #acdaac",
"#Z c #acdeac",
".T c #aceaac",
".3 c #aceeac",
".O c #b4dab4",
".Q c #b4deb4",
".1 c #b4eeb4",
"#0 c #b4f2b4",
"#k c #bde2bd",
".N c #bde6bd",
"#O c #bdf2bd",
".E c #c5eec5",
".R c #c5f2c5",
".P c #cdeacd",
".H c #cdf2cd",
".S c #cdf6cd",
"#Y c #d5eed5",
"#R c #d5f6d5",
".Y c #deeede",
"#z c #def2de",
".G c #def6de",
"#. c #defade",
".0 c #e6f6e6",
".F c #e6fae6",
".8 c #eef2ee",
".9 c #eefaee",
"#X c #eeffee",
"#G c #f6fff6",
".Z c #ffffff",
"QtQtQtQtQt.#.a.b.c.c.b.d.eQtQtQtQtQt",
"QtQtQtQt.f.g.h.i.j.k.l.m.n.oQtQtQtQt",
"QtQtQt.p.q.r.s.t.u.v.w.x.y.z.AQtQtQt",
"QtQt.p.B.C.D.E.F.F.F.G.H.u.I.J.AQtQt",
"Qt.o.K.L.M.E.N.O.P.Q.H.R.S.T.I.z.oQt",
".U.n.V.W.M.X.Y.Z.Z.Z.0.1.2.3.4.5.n.e",
".d.h.6.7.v.8.Z.9#..0.R###a#b#c#d#e#f",
"#g#h#i#j#k.Z.G#l#m#n#o#p.W#q#r#s#t.b",
".c#u#v#w.9.Z.2#w#x#y.N#z.9.H#A#B#u.c",
"#C#D#E#F.F#G#H#F#I.Z.Z.Z.Z.9#J#K#L.c",
".b.i#M#N#O.Z.H#P#Q#G.Z.Z.Z#R#N#S.i.b",
"#T.h#U#V#W#X.Z#Y#Z#G.Z.Z.Z#0#V#U#e.d",
".e.n#1#2#3#4#X.Z.Z.Z.Z#G.Z#5#6#7#8.e",
"Qt.o#9a.#Fa#aaab#l#Hacad#laca..zaeQt",
"QtQt.A.Jafagaaahaiahaiahajak.J.AQtQt",
"QtQtQt.A.z.yalaman#qaoap.y.zaqQtQtQt",
"QtQtQtQt.o.narasatatauav#8.oQtQtQtQt",
"QtQtQtQtQt.e#T.b#C.c#g.d.UQtQtQtQtQt"};

static const char* const t_delete_icon_data[] = { 
"16 16 80 2",
"Qt c None",
".P c #000000",
"#i c #180000",
".G c #200000",
".e c #200808",
".O c #410000",
".Y c #4a0000",
".o c #4a3c39",
"#h c #520400",
"#k c #5a0408",
".v c #5a484a",
"#l c #940400",
"#g c #ac0000",
"#j c #b40000",
"#n c #b40408",
"#f c #b40808",
".F c #b43031",
"#. c #bd0408",
"#c c #bd0808",
"#m c #bd0810",
".n c #bd4c52",
".5 c #c50408",
".X c #cd0c08",
".u c #d56562",
".N c #e62020",
"#d c #f60000",
".d c #f6797b",
".7 c #ff0000",
".4 c #ff0400",
"#e c #ff0408",
"## c #ff0808",
".Z c #ff0c10",
".6 c #ff1010",
".w c #ff1818",
".8 c #ff1c20",
".Q c #ff2420",
".1 c #ff2429",
".0 c #ff2829",
".W c #ff2c31",
"#a c #ff3431",
".H c #ff3439",
".V c #ff3839",
".R c #ff4041",
".M c #ff4441",
".L c #ff5052",
".E c #ff595a",
".D c #ff5d5a",
".B c #ff7173",
".t c #ff757b",
".# c #ff797b",
".s c #ff7d7b",
".C c #ff7d83",
".A c #ff8183",
".y c #ff8583",
".a c #ff858b",
".b c #ff898b",
".c c #ff8d8b",
".r c #ff8d94",
".I c #ff9194",
".q c #ff999c",
"#b c #ff9d9c",
".x c #ff9da4",
".2 c #ffa1a4",
".z c #ffa5a4",
".m c #ffa5ac",
".p c #ffaeac",
".S c #ffb2b4",
".l c #ffb6b4",
".g c #ffb6bd",
".h c #ffbabd",
".k c #ffc2c5",
".j c #ffc6c5",
".i c #ffc6cd",
".K c #ffdede",
".9 c #ffdee6",
".T c #ffe6ee",
".3 c #fff2f6",
".J c #fff6ff",
".U c #fffaff",
".f c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQt.#.a.b.c.b.b.d.eQtQtQtQt",
"QtQt.f.b.g.h.i.j.k.l.m.n.oQtQtQt",
"QtQt.g.p.q.b.r.r.b.s.t.#.u.vQtQt",
"Qt.w.x.y.t.z.A.#.B.c.C.D.E.F.GQt",
"Qt.H.b.E.I.f.k.E.B.J.K.L.M.N.O.P",
"Qt.Q.E.R.E.h.f.S.T.U.t.V.W.X.Y.P",
"Qt.w.Q.Z.0.1.2.f.3.L.w.w.4.5.O.P",
"Qt.6.w.7.7.8.9.3.f.b.7.7.7#..O.P",
"Qt####.7#a.T.3.H.A.f#b##.7#c.O.P",
"Qt#d#e.7.0.k.R.7.7#b.r.4.7#f.O.P",
"Qt.G#g.7.7#e.7.7.7.7.7.7.5#h.P.P",
"QtQt#i#j.7.7.7.7.7.7.7.5#k.P.P.P",
"QtQtQt#i#l#m#f#f#f#f#n#h.P.P.PQt",
"QtQtQtQt#i.Y.Y.O.O.O.O.P.P.PQtQt",
"QtQtQtQtQt.P.P.P.P.P.P.P.PQtQtQt"};

static const char* const t_config_icon_data[] = { 
"16 16 54 1",
". c None",
"b c #39385a",
"g c #5a597b",
"f c #5a5d7b",
"u c #625d7b",
"n c #625d83",
"A c #6a698b",
"Q c #6a6d8b",
"J c #737194",
"D c #737594",
"X c #7b7594",
"V c #7b7994",
"Z c #7b799c",
"K c #7b7d9c",
"L c #837d9c",
"q c #83819c",
"o c #8381a4",
"a c #8385a4",
"# c #8b85a4",
"W c #8b89a4",
"U c #8b89ac",
"T c #8b8dac",
"E c #948dac",
"P c #9491ac",
"S c #9491b4",
"O c #9495ac",
"Y c #9c95b4",
"N c #9c9db4",
"I c #a49dbd",
"H c #a4a1bd",
"C c #acaabd",
"z c #acaac5",
"R c #b4b2c5",
"x c #b4b2cd",
"w c #b4b6cd",
"t c #bdb6cd",
"M c #bdbacd",
"r c #c5bed5",
"m c #c5c2d5",
"l c #cdcade",
"k c #cdcede",
"j c #d5d2e6",
"i c #d5d6e6",
"e c #dedae6",
"v c #dedee6",
"h c #dedeee",
"d c #e6e2ee",
"c c #e6e6ee",
"G c #eee6f6",
"F c #eeeaf6",
"B c #eeeef6",
"y c #f6f2ff",
"s c #f6f6ff",
"p c #fff6ff",
"....#a#a#.......",
"....bcddefg.....",
"....#bdhhijg....",
".....abeijkf....",
"#a....#ajklmn...",
"opq...qjklmrg...",
"#sda.ajklmrtu...",
"qsveqjllmrwxg...",
"#yhijklmrtxzn...",
"qABjklmrtxCzDf..",
".bEFFcGdjmzHIJn.",
".abbqqKLqMMNOPQf",
"...obbbbbLMRSTUA",
"........qbVtCWqq",
".........obXtHoK",
"..........qbJxYZ"};

static const char* const t_help_icon_data[] = { 
"16 18 38 1",
". c None",
"y c #000000",
"d c #000000",
"x c #000000",
"H c #000000",
"c c #000000",
"G c #000000",
"t c #000000",
"n c #000000",
"s c #000000",
"w c #000000",
"J c #000000",
"D c #000000",
"B c #000000",
"v c #000000",
"r c #000000",
"C c #000000",
"l c #000000",
"k c #000000",
"I c #000000",
"j c #000000",
"q c #000000",
"b c #000000",
"a c #00385a",
"# c #003862",
"h c #00406a",
"o c #004473",
"g c #00508b",
"f c #005594",
"F c #00599c",
"e c #2981c5",
"u c #2985c5",
"m c #3185c5",
"z c #4191cd",
"p c #5299cd",
"i c #6aaad5",
"A c #6aaade",
"E c #8bbee6",
"....#a#a#abcd...",
"...aefbbbfgbbcd.",
"..hifbjklamgfbnd",
"..opbqrstsaugbvc",
"..#efbwx.yhzfblt",
"..cagfbnd.hzgblt",
"..ynbbbvcaAfbqvc",
"...ynBCDaEFbqrnd",
"....ycGaAFbqrnd.",
"......augbqrnd..",
"......#efbksd...",
"......cbbqvc....",
"......ynBBnd....",
".......aasx.....",
"......#ifbnd....",
"......HbbIJH....",
"......ynBBnd....",
".......yccd....."};

static const char* const t_new_icon_data[] = { 
"16 16 51 1",
"d c None",
"e c None",
"p c None",
"m c None",
"c c None",
". c None",
"r c #7b859c",
"E c #7b85a4",
"b c #7b89a4",
"B c #acbacd",
"w c #b4bacd",
"f c #b4becd",
"a c #b4bed5",
"# c #bdc2d5",
"v c #bdc6d5",
"A c #c5cade",
"K c #c5cede",
"Q c #cdcede",
"R c #cdcee6",
"U c #cdd2de",
"J c #cdd6e6",
"I c #d5d6e6",
"k c #d5dae6",
"V c #d5daee",
"W c #dedae6",
"u c #dedee6",
"l c #dedeee",
"o c #dee2ee",
"t c #e6e6ee",
"D c #e6e6f6",
"j c #e6eaf6",
"i c #eeeaf6",
"n c #eeeef6",
"z c #f6eef6",
"s c #f6f2ff",
"y c #f6f6f6",
"h c #f6f6ff",
"x c #ff9500",
"C c #ff9900",
"G c #ffc600",
"H c #ffca00",
"g c #fffaff",
"F c #ffff18",
"P c #ffff5a",
"L c #ffff62",
"M c #ffff8b",
"O c #ffff94",
"N c #ffffbd",
"S c #ffffcd",
"T c #ffffd5",
"q c #ffffff",
"....#a#a#a#abcde",
"....fghhijklfb.m",
"....#gghnjol##bp",
"....fqhhnnllrbrb",
"....#gghsntukvwr",
"....xxyhnzooAaBb",
".xC.CxgxCnDlA##E",
"xFGxFFxHFxIJKKvb",
".xLMNNOPClkJIQRr",
"..xHSTGxolkkIIUb",
".xLMNNOLColkkJIE",
"xFGxFFxHFxulJIUb",
".xC.CxixCookVIIr",
"....xxttoouWIIUb",
"....#nittookkJIE",
"....rbrbrbrbrbrb"};

static const char* const t_find_icon_data[] = { 
"16 16 166 2",
"Qt c None",
"aG c #000000",
".y c #395062",
"ah c #000000",
".H c #313c41",
"aq c #000000",
"aF c #000000",
".x c #000000",
".M c #000000",
"#J c #080000",
"#Y c #080400",
"#u c #000000",
".g c #000408",
"#. c #000000",
"#i c #080008",
".q c #000000",
".T c #000000",
".3 c #000000",
".r c #739dd5",
"aJ c #080400",
"aH c #100400",
".# c #739dd5",
".f c #294462",
".G c #001020",
"ar c #181000",
"ai c #180c00",
"#8 c #180c00",
"aE c #183862",
".h c #7ba1d5",
"#7 c #082c62",
"ag c #103062",
"aI c #201400",
".9 c #000c18",
"ap c #103062",
"#S c #201810",
".z c #739dd5",
".a c #73a1d5",
"#X c #7b4400",
"#I c #7b4400",
"a# c #834c00",
"#h c #8b8100",
"#t c #734000",
".L c #00305a",
".S c #003052",
".p c #39658b",
".2 c #00305a",
"au c #623800",
".w c #184473",
"av c #4a89e6",
"#D c #202829",
"ax c #528de6",
"aB c #4a89e6",
"az c #5289e6",
"aA c #528de6",
"ay c #528dee",
"aC c #528dee",
".e c #6295c5",
"aw c #5a91ee",
"aD c #418df6",
".d c #73a1cd",
".c c #7ba5d5",
"#K c #a4c6ff",
"#v c #a4caff",
"#Z c #accaff",
"#j c #acceff",
"## c #6a8dc5",
".8 c #3165a4",
"an c #accaff",
".4 c #315983",
".b c #83aede",
".s c #94bae6",
".i c #94bae6",
".F c #5289b4",
"#R c #5271a4",
"#T c #834808",
"aj c #8b4c08",
"#g c #5a89a4",
".N c #73a5d5",
"#C c #104883",
"#A c #18508b",
"#B c #185594",
"#y c #204462",
"#z c #205d94",
"#l c #396da4",
"#p c #396dc5",
"#a c #4a7dac",
"#P c #5a657b",
"#q c #5a697b",
"#O c #62697b",
"#Q c #626d83",
"#f c #6289f6",
".U c #6aa1d5",
"#N c #73859c",
"#m c #73a1de",
"#k c #7b8594",
"#o c #7b95ff",
"as c #835008",
"#9 c #8b5008",
"#d c #8ba5f6",
"#n c #8ba5ff",
".I c #8bb2e6",
"#6 c #8bb6ff",
"af c #8bbaff",
"#e c #94a5ff",
".6 c #94b2f6",
"#c c #94b2ff",
".R c #94c2f6",
"at c #9c5d20",
"#x c #9ca5b4",
".7 c #9cb6ff",
".5 c #9cbaff",
".1 c #9cbeff",
".0 c #a4c2ff",
".Z c #a4c6ff",
".o c #a4cae6",
"#b c #acc6ff",
".Y c #accaff",
".X c #acceff",
".Q c #acd2ff",
".K c #acd6ff",
"am c #b47110",
".W c #b4d2ff",
".j c #b4d6f6",
".P c #b4d6ff",
"#M c #bdc6e6",
"#5 c #bdcef6",
"#4 c #bdd2f6",
".A c #bddaf6",
".J c #bddeff",
".v c #bde6ff",
"#E c #c57108",
"#U c #c58531",
"al c #c5954a",
"ad c #c5daff",
".V c #c5e2ff",
".E c #c5eaff",
"ak c #cd8d41",
"#3 c #cddaff",
"#2 c #cddeff",
"ae c #cde2ff",
".D c #cde6ff",
"ao c #d5deff",
"ac c #d5e2ff",
"ab c #d5e6ff",
"#G c #dec29c",
"aa c #dee6ff",
".O c #deeaff",
"#F c #e6a129",
"#V c #e6c694",
"#1 c #e6eeff",
".C c #e6f2ff",
".k c #e6f6ff",
"a. c #eebe7b",
"#W c #eec27b",
"#H c #eec283",
"#L c #eeeeff",
".t c #eef6ff",
".B c #eefaff",
".u c #eeffff",
"#0 c #f6f6ff",
".n c #f6faff",
"#r c #f6ff73",
".m c #f6ffff",
"#s c #ffe66a",
"#w c #fffaff",
".l c #ffffff",
"QtQt.#.a.b.c.d.e.f.gQtQtQtQtQtQt",
"Qt.h.i.j.k.l.m.n.o.p.qQtQtQtQtQt",
".r.s.k.l.l.n.n.t.u.v.w.x.yQtQtQt",
".z.A.l.l.n.B.C.C.D.E.F.G.HQtQtQt",
".I.m.l.n.n.t.C.D.J.J.K.L.MQtQtQt",
".N.B.t.t.C.O.J.P.Q.P.R.S.TQtQtQt",
".U.E.D.V.V.W.X.Y.Z.0.1.2.3QtQtQt",
".4.R.J.P.X.Y.0.5.6.7.8.9#.QtQtQt",
"###a.J.W#b.1#c#d#e#f#g#h#iQtQtQt",
"#j#k#l#m.0.7#n#o#p#q#r#s#t#uQtQt",
"#v#w#x#y#z#A#B#C#D#E#F#G#H#I#JQt",
"#K.l#L#M#N#O#P#Q#R#S#T#U#V#W#X#Y",
"#Z#0#1#2#3#4#5#5#6#7#8#9#U#Va.a#",
"#v.naaabacacadaeafagahaiajakalam",
"an.taaao#2#2adadafapaqQtarasatau",
"avawaxayazaAaBaCaDaEaFaGQtaHaIaJ"};

static const char* const t_about_icon_data[] = { 
"16 16 68 2",
"Qt c None",
"#a c #002441",
".8 c #00244a",
".r c #00284a",
".1 c #002852",
".W c #002c52",
".4 c #003052",
".Q c #00305a",
".V c #00345a",
".y c #003462",
"## c #003862",
"#b c #00386a",
".# c #003c6a",
".I c #003c73",
".b c #00406a",
".a c #00446a",
".s c #004473",
".P c #004873",
".z c #082c4a",
".R c #082c52",
".j c #083052",
".k c #08406a",
".d c #084073",
".c c #084473",
".U c #08487b",
".x c #084c7b",
".9 c #084c83",
".J c #102c4a",
".7 c #103c62",
".i c #10446a",
".H c #104c7b",
"#. c #10507b",
".q c #105583",
".p c #184862",
".h c #185583",
".O c #185983",
".0 c #185d8b",
".S c #185d94",
".w c #18618b",
".K c #186594",
".Y c #204c62",
".v c #20506a",
".e c #205d7b",
".A c #20618b",
".Z c #20658b",
".5 c #206594",
".g c #20698b",
".2 c #20699c",
".M c #295573",
".l c #296183",
".N c #296d94",
".G c #296d9c",
".f c #297194",
".F c #317194",
".X c #3179a4",
".E c #39799c",
".m c #397da4",
".3 c #3981a4",
".n c #3981ac",
".T c #4185ac",
".B c #4189b4",
".t c #418db4",
".u c #4a91b4",
".C c #5299bd",
".D c #5299c5",
".L c #529dc5",
".6 c #fffaff",
".o c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQt.#.#.#.a.bQtQtQtQtQt",
"QtQtQtQt.c.d.e.f.g.h.i.j.cQtQtQt",
"QtQtQt.k.l.m.n.o.o.p.q.d.r.cQtQt",
"QtQtQt.s.m.t.u.o.o.v.w.x.y.zQtQt",
"QtQt.#.A.B.C.D.u.E.F.G.H.I.y.JQt",
"QtQt.#.K.t.L.o.o.o.M.N.O.P.Q.RQt",
"QtQt.#.S.T.C.D.o.o.v.N.O.U.V.WQt",
"QtQt.V.q.X.t.u.o.o.Y.Z.0.P.Q.1Qt",
"QtQt.y.k.2.m.3.o.o.p.O.q.#.4.rQt",
"QtQtQt.1.U.5.6.o.o.o.7.#.W.8QtQt",
"QtQtQt.c.r.#.x.9#.#.##.4#a.cQtQt",
"QtQtQtQt.c.r###b.V.W.r#a.cQtQtQt",
"QtQtQtQtQtQt.R.R.W.8.rQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const t_comment_icon_data[] = { 
"16 16 110 2",
".e c None",
".f c None",
".d c None",
".# c None",
".i c #ffffff",
".q c #ffffff",
"Qt c #ffffff",
".9 c #ffffff",
".3 c #ffffff",
".r c #ac856a",
".g c #b4896a",
".W c #180c08",
"#w c #181410",
".2 c #201010",
".8 c #201410",
"#d c #292020",
"#k c #312c29",
"#C c #39507b",
"#p c #4a4039",
"#e c #4a658b",
"#u c #526da4",
"#R c #5271ac",
".p c #5275ac",
"#c c #5a4c41",
"#l c #5a555a",
".c c #5a75ac",
"#x c #626162",
"#q c #6a696a",
".F c #6a85b4",
"#b c #7b5d4a",
"#j c #7b5d52",
".V c #835029",
".1 c #835031",
".Q c #835531",
"#B c #8391a4",
"#D c #8b8583",
"#J c #8b91a4",
"#H c #8b95a4",
"#I c #8b95ac",
"#n c #948583",
"#G c #9499ac",
"#o c #9c7d73",
"#A c #9ca1bd",
"#F c #9ca5b4",
".b c #9cb2de",
".G c #a48573",
"#z c #a4b2c5",
".a c #a4b6e6",
".A c #ac8573",
"#E c #acaeb4",
".z c #acbee6",
".7 c #b4795a",
"#i c #b48d7b",
".M c #b4917b",
"#a c #b49183",
".U c #bd7d41",
".P c #bd7d4a",
".H c #bd814a",
".C c #bd8541",
".6 c #bd856a",
"#v c #bdbabd",
"#y c #bdbecd",
"#m c #bdc6de",
"#N c #bdcae6",
"#t c #bdceee",
".O c #c58541",
".T c #c5854a",
".N c #c58952",
".t c #c58d52",
".S c #c5a59c",
"#r c #c5c6de",
"#s c #c5cee6",
"#M c #c5ceee",
".n c #c5d2ee",
"#Q c #cdd2ee",
".y c #cdd6ee",
"#L c #cdd6f6",
".E c #cddaee",
".o c #cddaf6",
"#g c #d5d2d5",
".L c #d5daee",
"#P c #d5daf6",
"#K c #d5deee",
".x c #d5def6",
".0 c #deaa94",
"#O c #dedef6",
".K c #dee2f6",
".m c #dee6f6",
".B c #e6ceac",
".s c #e6ceb4",
".h c #e6d2b4",
".4 c #e6e2ee",
".w c #e6e6f6",
".l c #e6eaf6",
".D c #e6eaff",
".5 c #eecabd",
"#. c #eedede",
".Y c #eee6e6",
"#f c #eeeaff",
".R c #eeeef6",
".v c #eeeeff",
".J c #eef2ff",
"#h c #f6dacd",
"## c #f6ded5",
".Z c #f6eee6",
".X c #f6f2ff",
".k c #f6f6ff",
".I c #fff6ff",
".u c #fffaff",
".j c #ffffff",
"Qt.#.a.b.a.b.a.b.a.b.c.d.e.f.g.h",
".i.#.b.j.k.k.l.m.n.o.b.p.q.r.s.t",
".#.#.a.j.u.k.v.w.x.y.a.z.A.B.t.C",
".#.#.b.j.k.k.l.D.E.o.F.G.s.t.C.H",
".#.#.a.j.I.k.J.l.K.L.M.h.N.O.P.Q",
".#.#.b.u.k.k.R.v.K.S.s.T.C.U.V.W",
".#.#.a.u.k.k.X.v.Y.Z.0.T.U.1.2.3",
".#.#.b.u.J.v.l.4.Z.5.6.7.Q.8.9.#",
".#.#.a.X.X.v.D#.###a#b#c#d#e.#.#",
".#.#.b.k.J#f#g#h#i#j#k#l#m.c.#.#",
".#.#.a.k.J.K#n#o#p#q#r#s#t#u.#.#",
".#.#.b.k.l#v#w#x#y#m#z#A#B#C.#.#",
".#.#.a.J.w#D#E#F#G#H#I#B#J#C.#.#",
".#.#.b.J.K.K#K.x.y#L.n#M#N.c.#.#",
".#.#.a.v.m.K#O#P#P.y#Q#M#t.p.#.#",
".#.##R.c#R.p#R.c#R.p#R.c#R.p.#.#"};


static const char* const t_remove_export_icon_data[] = {
       "16 16 80 2",
       "Qt c None",
       ".u c #000000",
       "#l c #103462",
       ".B c #182c41",
       "#k c #207dde",
       "#g c #2085e6",
       "#m c #2089f6",
       "#h c #208df6",
       "#j c #2091ff",
       ".J c #295983",
       "#f c #2989ee",
       "#d c #298dee",
       "## c #2991f6",
       "#n c #2991ff",
       "#i c #2995ff",
       ".9 c #318dee",
       "#. c #3191f6",
       ".6 c #3195f6",
       ".4 c #398dee",
       ".2 c #3995f6",
       ".3 c #3999f6",
       ".Y c #4199f6",
       ".Z c #41a1ff",
       ".P c #4a8dd5",
       ".W c #4aa5ff",
       ".A c #5a91d5",
       ".N c #5aaeff",
       ".y c #6295d5",
       ".G c #62b2ff",
       ".p c #6a99d5",
       ".x c #6a9dde",
       ".t c #6aa1de",
       ".Q c #6ab2ff",
       ".O c #6ab6ff",
       ".R c #73b6ff",
       ".X c #73baff",
       ".l c #7bb6f6",
       "#e c #7bbaf6",
       "#a c #7bbaff",
       ".H c #83beff",
       ".f c #83c2ff",
       ".8 c #8bc2f6",
       ".K c #8bc6ff",
       ".r c #94baee",
       ".e c #9ccaff",
       ".d c #9cceff",
       ".1 c #a4cef6",
       ".o c #a4ceff",
       ".q c #acd2ff",
       ".c c #acd6ff",
       ".w c #b4d6ff",
       ".k c #b4daff",
       ".V c #bddaf6",
       ".h c #bddaff",
       ".b c #bddeff",
       ".F c #c5deff",
       ".j c #c5e2ff",
       "#b c #cddee6",
       ".i c #cde6ff",
       ".7 c #d5dee6",
       "#c c #d5deee",
       ".S c #d5e2ee",
       ".v c #d5e6ff",
       ".g c #d5eaff",
       ".5 c #dedade",
       ".0 c #dee2ee",
       ".U c #dee6ee",
       ".L c #deeaf6",
       ".s c #deeeff",
       ".T c #e6eaf6",
       ".m c #e6eeff",
       ".n c #e6f2ff",
       ".M c #eeeef6",
       ".D c #eef2f6",
       ".C c #eef2ff",
       ".I c #f6f2ff",
       ".E c #f6f6ff",
       ".a c #f6faff",
       ".z c #fffaff",
       ".# c #ffffff",
       "QtQtQt.#.#.#.#.#.#.#.#.#.#.#.#Qt",
       "QtQt.#.#.a.b.c.d.d.#.a.b.c.e.fQt",
       "Qt.#.#.g.h.i.j.h.b.h.k.i.j.k.k.l",
       ".#.#.m.h.n.#.#.#.c.c.n.#.#.#.o.p",
       ".#.a.j.n.#.#.#.q.r.s.#.#.#.q.t.u",
       ".#.j.v.#.#.#.w.x.j.#.#.#.w.y.u.u",
       ".b.j.z.z.z.b.A.c.z.a.z.b.A.B.u.u",
       ".q.C.D.E.F.G.H.I.D.E.F.G.J.u.uQt",
       ".K.L.D.M.v.N.O.L.D.M.v.N.P.uQtQt",
       ".Q.R.S.T.U.V.W.X.S.T.U.V.W.YQtQt",
       ".#.Z.Q.S.U.0.1.2.Q.S.U.0.1.3.4Qt",
       ".#.5.6.R.7.S.7.8.9.R.7.S.7.8#..u",
       ".#.#.u###a#b#c#b.R#d#e#b#c#b.R#f",
       "Qt.#.##g#h#i#j#i#k#l#m#i#n#i#k.u",
       "QtQtQtQt.u.u.u.u.u.u.u.u.u.u.u.u",
       "QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"
    };

static const char* const t_add_export_icon_data[] = {

      "16 16 78 2",
      ".# c None",
      ".y c #000000",
      "#k c #082441",
      "#j c #207dde",
      "#g c #2091ff",
      "#d c #297dd5",
      "#e c #297dde",
      "#l c #298df6",
      "#i c #2991ff",
      "#h c #2995ff",
      ".9 c #317dd5",
      ".7 c #3181d5",
      "#f c #3195ff",
      ".U c #3981cd",
      ".1 c #3981d5",
      ".Z c #398de6",
      ".D c #5aa5ee",
      ".t c #6295cd",
      ".E c #62aaf6",
      ".N c #62b2ff",
      ".w c #6aaaee",
      ".x c #6aaef6",
      ".6 c #6ab2f6",
      ".Y c #6ab2ff",
      ".S c #6ab6ff",
      ".p c #73b2ee",
      ".s c #73b2f6",
      ".v c #73b6f6",
      ".A c #73b6ff",
      "#. c #73baff",
      "#c c #7bbaf6",
      ".o c #7bbeff",
      ".r c #83b6f6",
      "## c #83bef6",
      ".l c #83beff",
      ".m c #83c2ff",
      ".8 c #8bbef6",
      ".k c #8bc2ff",
      ".i c #8bc6ff",
      ".2 c #94c6ff",
      ".q c #9ccaff",
      ".d c #9cceff",
      ".3 c #a4cef6",
      ".J c #a4ceff",
      ".f c #a4d2ff",
      ".z c #accef6",
      ".j c #acd2ff",
      ".0 c #b4d2f6",
      ".c c #b4daff",
      ".V c #bddaf6",
      ".n c #bddaff",
      ".b c #bddeff",
      ".T c #c5def6",
      ".F c #c5deff",
      ".a c #c5e2ff",
      "#b c #cddee6",
      ".P c #cddef6",
      ".g c #cde6ff",
      ".5 c #d5dee6",
      "#a c #d5deee",
      ".4 c #d5e2ee",
      ".O c #d5e6f6",
      ".G c #d5e6ff",
      ".h c #d5eaff",
      ".W c #dee2ee",
      ".X c #dee2f6",
      ".R c #dee6ee",
      ".K c #dee6f6",
      ".M c #deeaff",
      ".e c #deeeff",
      ".u c #e6e2e6",
      ".Q c #e6eaf6",
      ".L c #eeeef6",
      ".H c #eef2f6",
      ".I c #f6f6ff",
      ".B c #f6faff",
      ".C c #fffaff",
      "Qt c #ffffff",
      "QtQtQtQtQtQtQtQtQtQtQtQt.#.#.#.#",
      "Qt.a.b.c.d.eQt.b.b.c.d.f.#.#.#.#",
      ".b.g.h.g.a.i.j.a.h.g.a.k.l.#.#.#",
      ".c.bQtQtQt.e.m.nQtQtQt.e.o.p.#.#",
      "Qt.q.bQtQtQt.g.r.bQtQtQt.g.s.t.#",
      "Qt.u.v.nQtQtQt.c.w.bQtQtQt.c.x.y",
      "QtQt.z.A.a.B.C.C.d.D.a.C.C.B.d.E",
      ".#QtQt.F.m.G.H.I.H.m.o.G.H.I.H.m",
      ".#QtQt.a.J.K.H.L.M.N.i.O.H.L.M.N",
      "QtQt.g.d.P.Q.R.K.N.S.T.Q.R.K.N.U",
      "Qt.e.f.V.R.W.X.Y.Z.0.R.W.W.N.1.y",
      "Qt.2.3.4.5.4.6.7.8.4.5.4.6.9.y.y",
      "#.###a#b#a#c#d.v#a#b#a#c#e.y.y.y",
      "Qt#f#g#h#i#j#k#l#i#h#g#j#k.y.y.#",
      ".#.y.y.y.y.y.y.y.y.y.y.y.y.y.#.#",
      ".#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#"
   };



static const char* const t_showc_icon_data[] = { 
"16 16 120 2",
"Qt c None",
"#K c None",
"#R c #4a4483",
".e c #7371ac",
".V c #525094",
".n c #9c95c5",
"#J c #41448b",
"#C c #7b75ac",
"#S c #6a65a4",
".3 c #9495c5",
".f c #8b89bd",
"#Q c #4a488b",
".m c #736dac",
".o c #9c95c5",
".# c #8b85bd",
"#v c #7375ac",
".I c #a4a1cd",
"#X c #52508b",
".2 c #524c94",
".y c #9c99c5",
"#B c #414083",
".P c #5a5d9c",
".x c #6a69a4",
".W c #9c9dcd",
"#1 c #5a5594",
"#L c #6a69a4",
"#b c #8b8dbd",
".a c #8381b4",
".p c #9495c5",
".Q c #9c9dc5",
"#I c #4a488b",
"#a c #4a488b",
".g c #8b89bd",
"#Y c #5a5d9c",
"#P c #52508b",
"#n c #8b85bd",
".d c #7b79b4",
".z c #9c99c5",
"#W c #525594",
".J c #a49dcd",
"#u c #4a488b",
".U c #525594",
"#D c #7b79ac",
"#A c #4a488b",
".H c #6a6da4",
"#0 c #62619c",
".4 c #9c95c5",
"#T c #6a69a4",
".b c #8b89bd",
"#H c #5a5994",
".h c #8b8dbd",
".l c #8381b4",
"#h c #525594",
"#i c #8b8dbd",
".q c #9c99c5",
".1 c #6a65a4",
".A c #a4a5cd",
".K c #acaad5",
"#O c #62619c",
"#w c #9c95c5",
".X c #b4b2d5",
".O c #7371ac",
"#M c #8b8dbd",
"#V c #7b75ac",
"#t c #625d9c",
"#z c #6a6da4",
".i c #b4b2d5",
"#c c #b4b2d5",
"#Z c #6a6da4",
".c c #8381b4",
".r c #acaed5",
"## c #8381b4",
".L c #cdcae6",
".R c #b4b2d5",
"#N c #8b8dbd",
"#m c #5a5594",
".w c #9c95c5",
".T c #a49dcd",
"#G c #8385b4",
"#s c #9491bd",
".B c #c5c2de",
"#E c #cdc6e6",
".5 c #dedeee",
"#U c #aca5cd",
"#o c #bdbad5",
"#y c #a4a1cd",
".j c #cdcae6",
".S c #e6e6f6",
"#f c #9491bd",
"#e c #9c95c5",
"#l c #9c9dc5",
"#g c #a4a1cd",
".k c #b4b6d5",
".G c #bdbad5",
".Y c #bdbade",
".0 c #bdbede",
".8 c #c5c2de",
"#r c #cdc6e6",
"#. c #cdcae6",
"#d c #cdcee6",
".v c #d5cee6",
"#j c #d5d2e6",
"#p c #d5d2ee",
".F c #d5d6ee",
"#k c #ded6ee",
".7 c #dedaee",
"#q c #dedaf6",
"#x c #dedeee",
".M c #e6deee",
".N c #e6def6",
".9 c #e6e2ee",
".Z c #e6e2f6",
".C c #e6e6f6",
".s c #eee6f6",
".E c #eeeaf6",
".6 c #eeeef6",
"#F c #f6f2ff",
".t c #fff6ff",
".u c #fffaff",
".D c #ffffff",
"QtQtQtQtQtQtQtQt.#.a.b.c.d.eQtQt",
"QtQtQtQtQtQt.f.g.h.i.j.k.l.mQtQt",
"QtQtQt.n.o.p.q.r.s.t.u.v.w.xQtQt",
"QtQt.y.z.A.B.C.D.D.D.E.F.G.HQtQt",
".I.J.K.L.s.D.D.D.D.u.F.M.N.O.PQt",
".Q.R.S.t.D.D.D.D.u.t.k.s.M.T.U.V",
".W.X.s.C.N.C.u.D.u.E.Y.Z.N.0.1.2",
".3.4.5.D.6.7.G.8.9.7.k.N.F#.###a",
"Qt#b#c.D.D.D.u#d#e#f.0#..v#.#g#h",
"Qt.f#i.C.D.D.u.Z#..8#j#k#..8#l#m",
"QtQt#n#o.D.D.t#p.s.9#q#j#r#s#t#u",
"QtQt#v#w.9.u.s.7.9#x#d#y#z#A#BQt",
"QtQt#C#D#E#F.Z#x.N.0#G#H#I#JQtQt",
"QtQt#K#L#M.C.7.v#N#O#P#Q#RQtQtQt",
"QtQtQt#S#T#o#U#V#W#XQtQtQtQtQtQt",
"QtQtQtQt#Y#Z#0#1QtQtQtQtQtQtQtQt"};

static const char* const t_deletec_icon_data[] = { 
"16 16 45 1",
"e c None",
"t c None",
"m c None",
"f c None",
"d c None",
". c None",
"w c #73819c",
"B c #7b819c",
"c c #7b859c",
"F c #acb6cd",
"A c #b4b6cd",
"a c #b4becd",
"b c #b4bed5",
"# c #bdbed5",
"s c #bdc2d5",
"z c #bdc6d5",
"E c #c5cad5",
"H c #c5cade",
"J c #c5cede",
"K c #cdcede",
"O c #cdd2de",
"I c #cdd2e6",
"N c #cdd6de",
"Q c #cdd6e6",
"k c #d5d6e6",
"M c #d5dae6",
"r c #d5dee6",
"v c #dedee6",
"l c #dedeee",
"q c #dee2ee",
"D c #e6e2ee",
"P c #e6e6ee",
"y c #e6e6f6",
"j c #e6eaf6",
"i c #eeeaee",
"p c #eeeaf6",
"u c #eeeef6",
"C c #eef2f6",
"o c #f6eeff",
"L c #f6f2f6",
"x c #f6f2ff",
"h c #f6f6ff",
"G c #ff0000",
"n c #fffaff",
"g c #ffffff",
"..#a#b#a#bcdef..",
"..aghhijklac.m..",
"..#gnhopqr#sct..",
"..aghhuuvlwcwc..",
"..#gnhxuyvkzAB..",
"..aghhCCDqEaFc..",
"..#GGhhuyGG##w..",
"..anGGppGGHHzc..",
"..#hxGGGGkIJKB..",
"..ahLuGGMMNIKc..",
"..#hxGGGlMkIIw..",
"..ahpGGGGvkkOc..",
"..#LGGPqGGMQkB..",
"..aGGyqqvGGkOc..",
"..#uyPPqlMMkIw..",
"..wcwcwcwcwcwc.."};


static const char* const m_import_icon_data[] = { 
"18 18 134 2",
".n c None",
"#T c #000000",
".m c #9c959c",
"Qt c #a49da4",
"#K c #000000",
".E c #000000",
"#s c #000000",
"#B c #000000",
"#j c #202020",
".# c #838183",
".l c #736d73",
".3 c #000000",
"#i c #000000",
"ad c #000000",
"#L c #000000",
"#S c #000000",
"#. c #000000",
"#A c #000000",
"#1 c #000000",
".T c #000000",
"#r c #000000",
".o c #838583",
"ac c #000000",
"#t c #202020",
".a c #7b757b",
"#8 c #414041",
".k c #7b757b",
".D c #5a5d5a",
"#k c #393439",
"## c #6a696a",
"#R c #000000",
"#J c #000000",
"#z c #000000",
".2 c #000000",
"#q c #000000",
"#h c #000000",
"aa c #000000",
"ab c #000000",
"#5 c #000000",
"#0 c #000000",
".9 c #000000",
".b c #838183",
".j c #aca5ac",
"#Q c #000000",
"#I c #000000",
"#W c #000000",
"#y c #080808",
"#p c #181418",
"a# c #080808",
".p c #7b757b",
"#g c #292829",
".C c #6a696a",
"#C c #5a555a",
"#l c #524c52",
"#u c #5a595a",
"#M c #525552",
".F c #7b757b",
".c c #837d83",
".i c #b4b2b4",
"#a c #5a5d5a",
".4 c #736d73",
"#o c #313031",
".S c #625d62",
"#H c #292c29",
"#x c #313031",
"#P c #202420",
"#f c #414441",
"#6 c #5a5d5a",
"#2 c #626162",
"#7 c #6a656a",
"#X c #5a5d5a",
".8 c #525052",
"#U c #5a595a",
"#4 c #202420",
"#Z c #292429",
"#V c #292829",
".q c #737173",
".d c #6a696a",
".h c #9c959c",
"#9 c #525052",
".B c #838183",
"a. c #4a4c4a",
"#N c #acaeac",
"#O c #626162",
"#D c #b4b6b4",
"#G c #5a555a",
"#n c #5a555a",
".1 c #5a595a",
"#w c #625d62",
".U c #626562",
".e c #6a696a",
"#b c #6a6d6a",
"#m c #736d73",
".r c #7b757b",
".f c #7b797b",
".G c #7b7d7b",
".R c #837d83",
".g c #838183",
".5 c #8b858b",
"#e c #8b898b",
"#c c #8b8d8b",
"#3 c #948d94",
".s c #949194",
".W c #949594",
".I c #9c999c",
".A c #9c9d9c",
".J c #a49da4",
".H c #a4a1a4",
".V c #a4a5a4",
".t c #aca5ac",
".K c #acaaac",
".u c #acaeac",
"#F c #b4aeb4",
".L c #b4b2b4",
".v c #b4b6b4",
".7 c #bdb6bd",
".X c #bdbabd",
"#d c #bdbebd",
".Q c #c5c2c5",
".w c #cdcecd",
".M c #d5ced5",
".Y c #d5d2d5",
".0 c #d5d6d5",
".6 c #ded6de",
".z c #dedade",
".N c #e6e2e6",
".x c #e6e6e6",
".Z c #eeeaee",
".y c #eeeeee",
"#Y c #f6eef6",
"#v c #f6f6f6",
".P c #fff6ff",
".O c #fffaff",
"#E c #ffffff",
"Qt.#.a.b.c.d.e.e.f.g.h.i.j.k.l.m.n.n",
".o.p.q.r.s.t.u.v.w.x.y.z.A.B.C.D.E.n",
".F.G.H.I.J.t.K.L.M.N.O.P.N.Q.R.S.T.E",
".U.K.V.I.W.V.K.X.Y.Z.O.y.0.Q.K.1.2.3",
".4.5.K.K.J.I.t.v.M.x.O.x.6.7.g.8.9#.",
"###a#b.g#c.s.A.u#d.6.z.7#e#b#f#g#h#i",
"#j#k#l.f#e#m.e.e.r.g.s.R#n#o#p#q#r#s",
".n#s#t#u.K#v.Z.Q.A.J.g#w#x#y#z#A#B.n",
".n.n.E#.#C#D#E.x#F#c#G#H#I#J#..E.n.n",
".n.n.n#K#L#M#N.Z.I#O#P#Q#R#S#K.n.n.n",
".n.n.n.n#T#S#U.z.5#V#W#z#S#T.n.n.n.n",
".n.n.n.n.n#T#X#Y.G#Z#0#1#K.n.n.n.n.n",
".n.n.n.n.n.n#2.O#3#4#5#L.n.n.n.n.n.n",
".n.n.n.n.n.n#6#v.s#Z#5#L.n.n.n.n.n.n",
".n.n.n.n.n.n#7.N.L#4#5#L.n.n.n.n.n.n",
".n.n.n.n.n.n#8#9a.a#aa#i.n.n.n.n.n.n",
".n.n.n.n.n.n.E#rababac#s.n.n.n.n.n.n",
".n.n.n.n.n.n.n#sadad#s.n.n.n.n.n.n.n"};

static const char* const m_export_icon_data[] = { 
"18 18 111 2",
"Qt c None",
"#J c #000000",
".b c #000000",
".a c #000000",
"#K c #000000",
".I c #000000",
".g c #000000",
"#z c #000000",
"#S c #000000",
".u c #000000",
"#A c #000000",
".H c #000000",
".X c #000000",
".W c #000408",
".J c #080408",
"## c #080808",
"#n c #080c08",
"#k c #100c10",
"#m c #101010",
".3 c #181818",
".2 c #201c20",
".w c #292829",
".p c #313031",
"#s c #393439",
"#e c #393839",
".4 c #413c41",
".P c #414041",
".C c #414441",
".t c #4a444a",
"#u c #524841",
"#t c #524c4a",
".v c #525552",
".# c #5a595a",
".U c #6a696a",
".s c #6a6d6a",
".k c #736d73",
".n c #737173",
".T c #737573",
"#v c #7b6d62",
".B c #7b7573",
".K c #838583",
".l c #8b858b",
".G c #8b8983",
".r c #8b898b",
"#l c #949194",
"#f c #9c9594",
".f c #9c999c",
".6 c #a4a5a4",
"#o c #ac9d8b",
"#g c #ac9d94",
"#a c #aca19c",
".7 c #aca59c",
".O c #aca5ac",
".Y c #b4aaac",
".L c #b4aeb4",
"#I c #bda17b",
"#r c #bda583",
"#d c #bdaa94",
".1 c #bdae9c",
"#F c #bdb29c",
".e c #bdb6b4",
".x c #bdb6bd",
"#R c #c5a17b",
"#y c #c5a583",
"#Q c #c5aa83",
"#P c #c5aa8b",
"#j c #c5aa94",
"#. c #c5b29c",
"#E c #c5b2a4",
"#O c #c5b69c",
"#D c #c5b6a4",
".F c #c5bab4",
"#M c #c5beac",
"#C c #c5beb4",
".V c #c5bec5",
".q c #c5c2c5",
"#N c #cdbaac",
"#B c #cdc2bd",
"#L c #cdc6bd",
".Q c #cdc6c5",
".o c #cdcecd",
"#G c #d5bea4",
"#p c #d5cab4",
"#w c #decab4",
"#b c #ded2c5",
".5 c #ded6de",
".Z c #dedad5",
".A c #dedade",
".d c #dedede",
"#h c #e6d2bd",
".8 c #e6dad5",
".h c #e6dee6",
".E c #e6e2de",
".c c #e6e2e6",
"#H c #eeceac",
"#x c #eed2b4",
"#q c #eedabd",
"#i c #eedec5",
".9 c #eee2d5",
".S c #eee2de",
".R c #eee6e6",
".N c #eeeaee",
"#c c #f6e2cd",
".0 c #f6eae6",
".j c #f6eef6",
".m c #f6f6f6",
".z c #fff6f6",
".D c #fff6ff",
".M c #fffaf6",
".y c #fffaff",
".i c #ffffff",
"QtQtQtQt.#.#.#.#.#.#.#.#.#.a.bQtQtQt",
"QtQtQtQt.#.c.d.c.d.c.e.#.f.#.g.bQtQt",
"QtQtQtQt.#.h.i.i.i.i.j.k.i.f.#.g.bQt",
"QtQtQtQt.#.c.i.l.m.i.i.n.o.i.f.p.g.b",
"QtQtQtQt.#.q.l.i.l.j.i.r.n.s.t.p.u.a",
"Qt.l.v.w.r.x.y.z.A.B.C.D.E.F.G.p.H.I",
"Qt.v.J.K.L.M.y.N.O.P.J.Q.R.S.F.p.H.I",
"Qt.w.T.A.U.V.m.A.n.W.X.Y.Z.0.1.p.H.I",
"Qt.2.3.4.O.k.5.6.t.X.J.7.8.9#..p.H.I",
"Qt.2.X.W##.O.n.T.X.W.X#a#b#c#d.p.H.I",
"Qt##.J.X.J#e#f.P.J.X.J#g#h#i#j.p.H.I",
"Qt#k.X.W###l#m.W.X.W#n#o#p#q#r.p.H.I",
"Qt.K.J.X#s.#.##t#t#u#v#o#w#x#y.p.H.I",
"Qt.a#z#A.##B#C#C#D#E#F#G#x#H#I.p.H.I",
"Qt#J.a#K.##B#L#M#N#O#.#P#Q#I#R.p.H.I",
"QtQtQtQt.#.p.p.p.p.p.p.p.p.p.p.p.H.I",
"QtQtQtQt.a#z#A.H.H.H.H.H.H.H.H.H#S.a",
"QtQtQtQt#J.a#K.I.I.I.I.I.I.I.I.I.a.b"};

static const char* const m_borrow_icon_data[] = { 
"32 32 53 1",
". c None",
"# c None",
"a c #000000",
"V c #838583",
"U c #8b898b",
"S c #8b8d8b",
"T c #948d94",
"R c #949194",
"L c #949594",
"Q c #9c959c",
"H c #9c999c",
"Y c #9c9d9c",
"X c #a49da4",
"C c #a4a1a4",
"A c #a4a5a4",
"G c #aca5a4",
"q c #aca5ac",
"f c #acaaac",
"l c #acaeac",
"E c #b4aeac",
"p c #b4aeb4",
"c c #b4b2b4",
"B c #b4b6b4",
"t c #bdb6bd",
"o c #bdbabd",
"k c #bdbebd",
"n c #c5bec5",
"j c #c5c2c5",
"i c #c5c6c5",
"s c #cdc6cd",
"M c #cdcacd",
"O c #cdcecd",
"N c #d5ced5",
"P c #d5d2d5",
"J c #d5d6d5",
"I c #ded6de",
"F c #dedade",
"K c #dedede",
"W c #e6dee6",
"D c #e6e2e6",
"u c #e6e6e6",
"x c #eee6e6",
"y c #eee6ee",
"g c #eeeaee",
"v c #eeeeee",
"e c #f6eeee",
"d c #f6eef6",
"r c #f6f2ee",
"w c #f6f2f6",
"b c #f6f6f6",
"z c #fff6ff",
"m c #fffaff",
"h c #ffffff",
"................................",
"................................",
"#a############################a#",
"aba##########################aca",
"ada##########################aca",
"adea##aaa##############aaa##acfa",
"agda#ahhha############aijka#alfa",
"#agdaabhhha##########ajjkkaalfa#",
"#aggaammhha##########ajknoaapqa#",
"##aggarmmhha########asknttapqa##",
"##augaabmmha###aa###ajjooaafqa##",
"###augvwbmma##aaja##ajooccfqa###",
"###axygvwza#aahasiaa#aocclfAa###",
"####ayuggwbahhhajsjjaoBclfCa####",
"####aDyyevzzhhhasijnkBtEfACa####",
"#####aDxuvvwbmhaajkkBBpfACa#####",
"#####aDDyyddzaa##aaotcpfqCa#####",
"####aFFDDyxva######acpAGCCHa####",
"##aaIJFKDuga########affCCHHLaa##",
"#aMNOPJFKDDa########aqCCHHQRSSa#",
"aiMMNPaaaKDa########aACaaaQSTUUa",
"asiMMa###aKDa######aACa###aSUUVa",
"#aasa####aWWa######aCXa####aUaa#",
"###a######aWKa####aqCa######a###",
"##########aFWa####aCXa##########",
"###########aFWa##aCCa###########",
"############aFWaaACa############",
"############aFFaCCYa############",
"#############aFaCXa#############",
"##############aaYa##############",
"###############aa###############",
"................................"};

static const char* const t_sborrow_icon_data[] = { 
"32 32 56 1",
". c None",
"# c None",
"a c #000000",
"X c #8b898b",
"U c #8b8d8b",
"T c #949194",
"L c #949594",
"H c #9c999c",
"1 c #9c9d9c",
"0 c #a49da4",
"C c #a4a1a4",
"A c #a4a5a4",
"G c #aca5a4",
"q c #aca5ac",
"f c #acaaac",
"l c #acaeac",
"E c #b4aeac",
"p c #b4aeb4",
"c c #b4b2b4",
"B c #b4b6b4",
"t c #bdb6bd",
"o c #bdbabd",
"k c #bdbebd",
"n c #c5bec5",
"j c #c5c2c5",
"i c #c5c6c5",
"s c #cdc6cd",
"M c #cdcacd",
"O c #cdcecd",
"N c #d5ced5",
"P c #d5d2d5",
"J c #d5d6d5",
"I c #ded6de",
"F c #dedade",
"K c #dedede",
"Z c #e6dee6",
"D c #e6e2e6",
"u c #e6e6e6",
"R c #ee4841",
"x c #eee6e6",
"y c #eee6ee",
"g c #eeeaee",
"v c #eeeeee",
"S c #f64841",
"Q c #f6484a",
"Y c #f6ea41",
"W c #f6ee41",
"e c #f6eeee",
"d c #f6eef6",
"r c #f6f2ee",
"w c #f6f2f6",
"b c #f6f6f6",
"V c #ffee4a",
"z c #fff6ff",
"m c #fffaff",
"h c #ffffff",
"................................",
"................................",
"#a############################a#",
"aba##########################aca",
"ada##########################aca",
"adea##aaa##############aaa##acfa",
"agda#ahhha############aijka#alfa",
"#agdaabhhha##########ajjkkaalfa#",
"#aggaammhha##########ajknoaapqa#",
"##aggarmmhha########asknttapqa##",
"##augaabmmha###aa###ajjooaafqa##",
"###augvwbmma##aaja##ajooccfqa###",
"###axygvwza#aahasiaa#aocclfAa###",
"####ayuggwbahhhajsjjaoBclfCa####",
"####aDyyevzzhhhasijnkBtEfACa####",
"#####aDxuvvwbmhaajkkBBpfACa#####",
"#####aDDyyddzaa##aaotcpfqCa#####",
"####aFFDDyxva######acpAGCCHa####",
"##aaIJFKDuga########affCCHHLaa##",
"#aMNOPJFKDDa########aqCQRQSTUUa#",
"aiMMNPaaaKDa########aACSVWQSQXXa",
"asiMMa###aKDa##QSQRQSQRQYVYVSQRa",
"#aasa####aZZa##QVWVWVWVWVWVWVWQQ",
"###a######aZKa#QYVYVYVYVYVYVYVYQ",
"##########aFZa#SVWVWVWVWVWVWVWVS",
"###########aFZaQYVYVYVYVYVYVYVYQ",
"############aFZQVWVWVWVWVWVWVWQQ",
"############aFFQRQSQRQSQYVYVRQS#",
"#############aFaC0a####SVWQSQ###",
"##############aa1a#####QSQR#####",
"###############aa###############",
"................................"};

static const char* const t_cborrow_icon_data[] = { 
"32 32 50 1",
". c None",
"# c None",
"a c #000000",
"U c #838583",
"T c #8b898b",
"R c #8b8d8b",
"S c #948d94",
"C c #a4a1a4",
"A c #a4a5a4",
"J c #aca5a4",
"q c #aca5ac",
"f c #acaaac",
"l c #acaeac",
"E c #b4aeac",
"p c #b4aeb4",
"c c #b4b2b4",
"B c #b4b6b4",
"t c #bdb6bd",
"o c #bdbabd",
"k c #bdbebd",
"n c #c5bec5",
"j c #c5c2c5",
"i c #c5c6c5",
"s c #cdc6cd",
"N c #cdcacd",
"P c #cdcecd",
"O c #d5ced5",
"Q c #d5d2d5",
"L c #d5d6d5",
"K c #ded6de",
"I c #dedade",
"M c #dedede",
"V c #e6dee6",
"D c #e6e2e6",
"u c #e6e6e6",
"G c #ee4841",
"x c #eee6e6",
"y c #eee6ee",
"g c #eeeaee",
"v c #eeeeee",
"H c #f64841",
"F c #f6484a",
"e c #f6eeee",
"d c #f6eef6",
"r c #f6f2ee",
"w c #f6f2f6",
"b c #f6f6f6",
"z c #fff6ff",
"m c #fffaff",
"h c #ffffff",
"................................",
"................................",
"#a############################a#",
"aba##########################aca",
"ada##########################aca",
"adea##aaa##############aaa##acfa",
"agda#ahhha############aijka#alfa",
"#agdaabhhha##########ajjkkaalfa#",
"#aggaammhha##########ajknoaapqa#",
"##aggarmmhha########asknttapqa##",
"##augaabmmha###aa###ajjooaafqa##",
"###augvwbmma##aaja##ajooccfqa###",
"###axygvwza#aahasiaa#aocclfAa###",
"####ayuggwbahhhajsjjaoBclfCa####",
"####aDyyevzzhhhasijnkBtEfACa####",
"#####aDxuvvwbmhFGFkkBBpfACa#GFH#",
"#####aDDyyddzaaHFFFotcpfqCaHFFF#",
"####aIIDDyxva##FHFGFcpAJCCGFHFG#",
"##aaKLIMDuga####FHFFFffCCHFFFH##",
"#aNOPQLIMDDa#####FHFGFCCGFHFGRa#",
"aiNNOQaaaMDa######FHFFFHFFFHSTTa",
"asiNNa###aMDa######FHFGFHFGRTTUa",
"#aasa####aVVa######aFHFFFH#aTaa#",
"###a######aVMa####aqGFHFGF##a###",
"##########aIVa####aHFFFHFFF#####",
"###########aIVa##aGFHFGFHFGF####",
"############aIVaaHFFFH##FHFFF###",
"############aIIaGFHFG####FHFGF##",
"#############aIHFFFH######FHFFF#",
"##############aFHFG########FHFG#",
"###############FFH##########FHF#",
"................................"};




QPixmap * m_catalog_icon=NULL;
QPixmap * m_unknown_icon=NULL;
QPixmap * m_cd_icon=NULL;
QPixmap * m_dvd_icon=NULL;
QPixmap * m_hdd_icon=NULL;
QPixmap * m_net_icon=NULL;
QPixmap * m_flash_icon=NULL;
QPixmap * m_other_icon=NULL;
QPixmap * m_floppy_icon=NULL;
QPixmap * v_folderlocked_icon=NULL;
QPixmap * v_folderclosed_icon=NULL;
QPixmap * v_folderopen_icon=NULL;
QPixmap * v_file_icon=NULL;
QPixmap * v_back_icon=NULL;
QPixmap * a_0=NULL;
QPixmap * a_1=NULL;
QPixmap * a_2=NULL;
QPixmap * a_3=NULL;
QPixmap * a_4=NULL; 
QPixmap * p_icon=NULL; 
QPixmap * t_open_icon=NULL; 
QPixmap * t_save_icon=NULL; 
QPixmap * t_saveas_icon=NULL; 
QPixmap * t_close_icon=NULL; 
QPixmap * t_add_icon=NULL; 
QPixmap * t_rescan_icon=NULL; 
QPixmap * t_delete_icon=NULL; 
QPixmap * t_config_icon=NULL; 
QPixmap * t_help_icon=NULL; 
QPixmap * t_new_icon=NULL; 
QPixmap * t_find_icon=NULL; 
QPixmap * t_about_icon=NULL; 
QPixmap * t_add_export_icon=NULL;
QPixmap * t_remove_export_icon=NULL;
QPixmap * t_comment_icon=NULL;
QPixmap * t_deletec_icon=NULL;
QPixmap * t_showc_icon=NULL;
QPixmap * m_export_icon=NULL;
QPixmap * m_import_icon=NULL;
QPixmap * m_borrow_icon=NULL;
QPixmap * t_sborrow_icon=NULL;
QPixmap * t_cborrow_icon=NULL;


void init_icon_base(void)
 {

  if(  m_catalog_icon==NULL) 
     m_catalog_icon=new QPixmap((const char **)m_catalog_icon_data); 

  if(  m_unknown_icon==NULL) 
     m_unknown_icon=new QPixmap((const char **)m_unknown_icon_data); 

  if(  m_cd_icon==NULL) 
     m_cd_icon=new QPixmap((const char **)m_cd_icon_data); 

  if(  m_dvd_icon==NULL) 
     m_dvd_icon=new QPixmap((const char **)m_dvd_icon_data); 

  if(  m_hdd_icon==NULL) 
     m_hdd_icon=new QPixmap((const char **)m_hdd_icon_data); 

  if(  m_net_icon==NULL) 
     m_net_icon=new QPixmap((const char **)m_net_icon_data); 

  if(  m_flash_icon==NULL) 
     m_flash_icon=new QPixmap((const char **)m_flash_icon_data); 

  if(  m_other_icon==NULL)
     m_other_icon=new QPixmap((const char **)m_other_icon_data); 

  if(  m_floppy_icon==NULL) 
     m_floppy_icon=new QPixmap((const char **)m_floppy_icon_data); 

  if(  v_folderlocked_icon==NULL) 
     v_folderlocked_icon=new QPixmap((const char **)v_folderlocked_icon_data);

  if(  v_folderclosed_icon==NULL) 
     v_folderclosed_icon=new QPixmap((const char **)v_folderclosed_icon_data);

  if(  v_folderopen_icon==NULL) 
     v_folderopen_icon=new QPixmap((const char **)v_folderopen_icon_data);

  if(  v_file_icon==NULL) 
     v_file_icon=new QPixmap((const char **)v_file_icon_data);

  if(  v_back_icon==NULL) 
     v_back_icon=new QPixmap((const char **)v_back_icon_data); 

  if(  a_0==NULL) 
     a_0=new QPixmap((const char **)a_0_data); 

  if(  a_1==NULL)
     a_1=new QPixmap((const char **)a_1_data); 

  if(  a_2==NULL) 
     a_2=new QPixmap((const char **)a_2_data); 

  if(  a_3==NULL) 
     a_3=new QPixmap((const char **)a_3_data); 

  if(  a_4==NULL) 
     a_4=new QPixmap((const char **)a_4_data); 

  if(  p_icon==NULL) 
     p_icon=new QPixmap((const char **)p_icon_data); 

  if(  t_open_icon==NULL) 
     t_open_icon=new QPixmap((const char **)t_open_icon_data); 

  if(  t_save_icon==NULL) 
     t_save_icon=new QPixmap((const char **)t_save_icon_data); 

  if(  t_saveas_icon==NULL) 
     t_saveas_icon=new QPixmap((const char **)t_saveas_icon_data); 

  if(  t_close_icon==NULL)
     t_close_icon=new QPixmap((const char **)t_close_icon_data); 

  if(  t_add_icon==NULL)
     t_add_icon=new QPixmap((const char **)t_add_icon_data); 

  if(  t_rescan_icon==NULL) 
     t_rescan_icon=new QPixmap((const char **)t_rescan_icon_data); 

  if(  t_delete_icon==NULL)
     t_delete_icon=new QPixmap((const char **)t_delete_icon_data); 

  if(  t_config_icon==NULL)
     t_config_icon=new QPixmap((const char **)t_config_icon_data); 

  if(  t_help_icon==NULL)
     t_help_icon=new QPixmap((const char **)t_help_icon_data); 

  if(  t_new_icon==NULL)
     t_new_icon=new QPixmap((const char **)t_new_icon_data);

  if(  t_find_icon==NULL)
     t_find_icon=new QPixmap((const char **)t_find_icon_data);

  if(  t_about_icon==NULL)
     t_about_icon=new QPixmap((const char **)t_about_icon_data);

  if(  t_comment_icon==NULL)
     t_comment_icon=new QPixmap((const char **)t_comment_icon_data);

  if(  t_add_export_icon==NULL)
     t_add_export_icon=new QPixmap((const char **)t_add_export_icon_data);

  if(  t_remove_export_icon==NULL)
     t_remove_export_icon=new QPixmap((const char **)t_remove_export_icon_data);

  if(  t_showc_icon==NULL)
     t_showc_icon=new QPixmap((const char **)t_showc_icon_data);

  if(  t_deletec_icon==NULL)
     t_deletec_icon=new QPixmap((const char **)t_deletec_icon_data);

  if(  m_export_icon==NULL)
     m_export_icon=new QPixmap((const char **)m_export_icon_data);

  if(  m_import_icon==NULL)
     m_import_icon=new QPixmap((const char **)m_import_icon_data);

  if(  m_borrow_icon==NULL)
     m_borrow_icon=new QPixmap((const char **)m_borrow_icon_data);

  if(  t_sborrow_icon==NULL)
     t_sborrow_icon=new QPixmap((const char **)t_sborrow_icon_data);

  if(  t_cborrow_icon==NULL)
     t_cborrow_icon=new QPixmap((const char **)t_cborrow_icon_data);


 }

QPixmap * get_m_catalog_icon(void)
{
 return m_catalog_icon;
}

QPixmap * get_m_unknown_icon(void)
{
 return m_unknown_icon;
}

QPixmap * get_m_cd_icon(void)
{
 return m_cd_icon;
}

QPixmap * get_m_dvd_icon(void)
{
 return m_dvd_icon; 
} 

QPixmap * get_m_hdd_icon(void) 
{ 
 return m_hdd_icon; 
} 

QPixmap * get_m_net_icon(void) 
{ 
 return m_net_icon; 
} 

QPixmap * get_m_flash_icon(void) 
{ 
 return m_flash_icon; 
}

QPixmap * get_m_other_icon(void) 
{ 
 return m_other_icon; 
} 

QPixmap * get_m_floppy_icon(void) 
{ 
 return m_floppy_icon; 
} 

QPixmap * get_v_folderlocked_icon(void) 
{ 
 return v_folderlocked_icon; 
}

QPixmap * get_v_folderclosed_icon(void) 
{ 
 return v_folderclosed_icon; 
}

QPixmap * get_v_folderopen_icon(void) 
{ 
 return v_folderopen_icon; 
}

QPixmap * get_v_file_icon(void) 
{ 
 return v_file_icon; 
}

QPixmap * get_v_back_icon(void) 
{ 
 return v_back_icon; 
} 

QPixmap * get_p_icon(void) 
{ 
 return p_icon; 
} 

QPixmap * get_t_open_icon(void) 
{ 
 return t_open_icon; 
} 

QPixmap * get_t_save_icon(void) 
{ 
 return t_save_icon; 
} 

QPixmap * get_t_saveas_icon(void) 
{ 
 return t_saveas_icon; 
} 

QPixmap * get_t_close_icon(void) 
{ 
 return t_close_icon; 
} 

QPixmap * get_t_add_icon(void) 
{ 
 return t_add_icon; 
} 

QPixmap * get_t_rescan_icon(void) 
{ 
 return t_rescan_icon; 
} 

QPixmap * get_t_delete_icon(void) 
{ 
 return t_delete_icon; 
}

QPixmap * get_t_config_icon(void) 
{ 
 return t_config_icon; 
} 

QPixmap * get_t_help_icon(void) 
{ 
 return t_help_icon; 
} 

QPixmap * get_t_new_icon(void) 
{ 
 return t_new_icon; 
} 

QPixmap * get_t_find_icon(void) 
{ 
 return t_find_icon; 
} 

QPixmap * get_t_about_icon(void) 
{ 
 return t_about_icon; 
} 

QPixmap * get_t_comment_icon(void) 
{ 
 return t_comment_icon; 
} 

QPixmap * get_t_add_export_icon(void)
{
 return t_add_export_icon;
}

QPixmap * get_t_remove_export_icon(void)
{
 return t_remove_export_icon;
}

QPixmap * get_t_showc_icon(void)
{
 return t_showc_icon;
}

QPixmap * get_t_deletec_icon(void)
{
 return t_deletec_icon;
}

QPixmap * get_m_export_icon(void)
{
 return m_export_icon;
}

QPixmap * get_m_import_icon(void)
{
 return m_import_icon;
}

QPixmap * get_m_borrow_icon(void)
{
 return m_borrow_icon;
}

QPixmap * get_t_sborrow_icon(void)
{
 return t_sborrow_icon;
}

QPixmap * get_t_cborrow_icon(void)
{
 return t_cborrow_icon;
}

QPixmap * get_anim(int i)
{
  switch(i)
   {
    case 0: return a_0;
    case 1: return a_1;
    case 2: return a_2;
    case 3: return a_3;
    case 4: return a_4;
    default: return a_1;
   }
} 


